/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern2 (x3, 
E_V2DImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern2 (x3, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V16QImode:
      if (pattern2 (x3, 
E_V16QImode) != 0)
        return -1;
      return 7;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 8;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern2 (x3, 
E_V4DImode) != 0)
        return -1;
      return 10;

    case E_V8SImode:
      if (pattern2 (x3, 
E_V8SImode) != 0)
        return -1;
      return 11;

    case E_V16HImode:
      if (pattern2 (x3, 
E_V16HImode) != 0)
        return -1;
      return 12;

    case E_V32QImode:
      if (pattern2 (x3, 
E_V32QImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern27 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V1TImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern27 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern27 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern27 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2TImode:
      if (pattern27 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern27 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern27 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 6;

    case E_V16HImode:
      if (pattern27 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!reg_or_0_operand (operands[2], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_uimm6_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const_uimm3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern64 (x3, 
E_V4DImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern68 (x3, 
E_V8SImode, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V16HImode:
      if (pattern69 (x3, 
E_V16HImode, 
E_V16HImode) != 0)
        return -1;
      return 2;

    case E_V32QImode:
      if (pattern66 (x3, 
E_V32QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern86 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 2;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern97 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !arith_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !plus_di_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_val_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (REGNO (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  return pattern137 (x2); /* [-1, 2] */
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern27 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V1TImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern27 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern27 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern27 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2TImode:
      if (pattern27 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern27 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern27 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 6;

    case E_V16HImode:
      if (pattern27 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern184 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aq12w_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_immalsl_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1)
      || !scratch_operand (operands[7], i1))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 563; /* lsx_vfrintrne_d */

    case 1:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 568; /* lsx_vfrintrne_s */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 573; /* lasx_xvfrintrne_d */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 578; /* lasx_xvfrintrne_s */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern50 (x1))
    {
    case 0:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (9 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 409 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 198; /* lrintsfsi2 */

    case 1:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (9 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 409 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))))
        return -1;
      return 204; /* lrintdfsi2 */

    case 2:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (9 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 410 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))))
        return -1;
      return 201; /* lrintsfdi2 */

    case 3:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (9 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 410 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 207; /* lrintdfdi2 */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  switch (pattern136 (x5))
    {
    case 0:
      return 447; /* loongarch_crcc_w_b_w */

    case 1:
      return 449; /* loongarch_crcc_w_h_w */

    case 2:
      return 451; /* loongarch_crcc_w_w_w */

    case 3:
      if (
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return 453; /* loongarch_crcc_w_d_w */
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern138 (x2))
    {
    case 0:
      if (!
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 463; /* *crc_combine */

    case 1:
      if (!
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 465; /* *crc_combine */

    case 2:
      if (!
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 467; /* *crc_combine */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1970 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1835; /* lasx_xvsat_s_d */

    case 1:
      if (!
#line 1970 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1836; /* lasx_xvsat_s_w */

    case 2:
      if (!
#line 1970 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1837; /* lasx_xvsat_s_h */

    case 3:
      if (!
#line 1970 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1838; /* lasx_xvsat_s_b */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1096 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1682; /* lasx_xvavgr_s_d */

    case 1:
      if (!
#line 1096 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1683; /* lasx_xvavgr_s_w */

    case 2:
      if (!
#line 1096 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1684; /* lasx_xvavgr_s_h */

    case 3:
      if (!
#line 1096 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1685; /* lasx_xvavgr_s_b */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern67 (x1))
    {
    case 0:
      if (!
#line 1050 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1113; /* lsx_vbitseti_d */

    case 1:
      if (!
#line 1050 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1114; /* lsx_vbitseti_w */

    case 2:
      if (!
#line 1050 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1115; /* lsx_vbitseti_h */

    case 3:
      if (!
#line 1050 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1116; /* lsx_vbitseti_b */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 936 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1072; /* lsx_vavg_s_d */

    case 1:
      if (!
#line 936 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1073; /* lsx_vavg_s_w */

    case 2:
      if (!
#line 936 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1074; /* lsx_vavg_s_h */

    case 3:
      if (!
#line 936 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1075; /* lsx_vavg_s_b */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern87 (x1, pnum_clobbers))
    {
    case 0:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
        {
          x5 = XEXP (x3, 2);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && register_operand (operands[1], E_FCCmode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && GET_MODE (x3) == E_SImode
                      && (
#line 2479 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
                    return 164; /* fcc_to_si */
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && GET_MODE (x3) == E_DImode
                      && (
#line 2479 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                    return 165; /* fcc_to_di */
                  break;

                default:
                  break;
                }
            }
        }
      operands[2] = x4;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern189 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
                return -1;
              return 167; /* *selnesi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 171; /* *selnesi_using_di */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern189 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && ((((
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))))
                return -1;
              return 169; /* *selnedi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 173; /* *selnedi_using_di */

            default:
              return -1;
            }

        case E_SFmode:
          if (pattern190 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 174; /* *selsf */

        case E_DFmode:
          if (pattern190 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 175; /* *seldf */

        default:
          return -1;
        }

    case 1:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1289; /* lsx_bnz_d */

    case 2:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1291; /* lsx_bnz_w */

    case 3:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1293; /* lsx_bnz_h */

    case 4:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1295; /* lsx_bnz_b */

    case 5:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1297; /* lsx_bnz_d_f */

    case 6:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1299; /* lsx_bnz_w_f */

    case 7:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1301; /* lsx_bnz_v_d */

    case 8:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1303; /* lsx_bnz_v_w */

    case 9:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1305; /* lsx_bnz_v_h */

    case 10:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1307; /* lsx_bnz_v_b */

    case 11:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1309; /* lsx_bnz_v_d_f */

    case 12:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1311; /* lsx_bnz_v_w_f */

    case 13:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1900; /* lasx_xbnz_d */

    case 14:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1902; /* lasx_xbnz_w */

    case 15:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1904; /* lasx_xbnz_h */

    case 16:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1906; /* lasx_xbnz_b */

    case 17:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1908; /* lasx_xbnz_d_f */

    case 18:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1910; /* lasx_xbnz_w_f */

    case 19:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1912; /* lasx_xbnz_v_d */

    case 20:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1914; /* lasx_xbnz_v_w */

    case 21:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1916; /* lasx_xbnz_v_h */

    case 22:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1918; /* lasx_xbnz_v_b */

    case 23:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1920; /* lasx_xbnz_v_d_f */

    case 24:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1922; /* lasx_xbnz_v_w_f */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      return recog_70 (x1, insn, pnum_clobbers);

    case 2:
      return recog_71 (x1, insn, pnum_clobbers);

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x2, 1))
        {
        case 29:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern159 (x2, 
E_SImode) != 0
                  || !(
#line 2674 "../../gcc/config/loongarch/loongarch.md"
(HAVE_AS_TLS_LE_RELAXATION) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return -1;
              return 190; /* add_tls_le_relaxsi */

            case E_DImode:
              if (pattern159 (x2, 
E_DImode) != 0
                  || !(
#line 2674 "../../gcc/config/loongarch/loongarch.md"
(HAVE_AS_TLS_LE_RELAXATION) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return -1;
              return 191; /* add_tls_le_relaxdi */

            default:
              return -1;
            }

        case 91:
          return recog_69 (x1, insn, pnum_clobbers);

        case 106:
          if (!const_uimm5_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern58 (x2, 
E_V8HImode) != 0
                  || !
#line 2215 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1375; /* lsx_vfrstpi_h */

            case E_V16QImode:
              if (pattern58 (x2, 
E_V16QImode) != 0
                  || !
#line 2215 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1376; /* lsx_vfrstpi_b */

            default:
              return -1;
            }

        case 107:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern160 (x2, 
E_V8HImode) != 0
                  || !
#line 2226 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1377; /* lsx_vfrstp_h */

            case E_V16QImode:
              if (pattern160 (x2, 
E_V16QImode) != 0
                  || !
#line 2226 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1378; /* lsx_vfrstp_b */

            default:
              return -1;
            }

        case 108:
          if (pattern143 (x2, 
E_V2DImode) != 0
              || !
#line 2237 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1379; /* lsx_vshuf4i_d */

        case 111:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 2268 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1390; /* lsx_vextrins_d */

            case 1:
              if (!
#line 2268 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1391; /* lsx_vextrins_w */

            case 2:
              if (!
#line 2268 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1392; /* lsx_vextrins_h */

            case 3:
              if (!
#line 2268 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1393; /* lsx_vextrins_b */

            default:
              return -1;
            }

        case 132:
          if (pattern145 (x2, 
E_V16QImode) != 0
              || !
#line 2743 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1465; /* lsx_vshuf_b */

        case 143:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3070 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1482; /* lsx_vsrlni_d_q */

            case 1:
              if (!
#line 3070 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1483; /* lsx_vsrlni_w_d */

            case 2:
              if (!
#line 3070 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1484; /* lsx_vsrlni_h_w */

            case 3:
              if (!
#line 3070 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1485; /* lsx_vsrlni_b_h */

            default:
              return -1;
            }

        case 144:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3081 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1486; /* lsx_vsrlrni_d_q */

            case 1:
              if (!
#line 3081 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1487; /* lsx_vsrlrni_w_d */

            case 2:
              if (!
#line 3081 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1488; /* lsx_vsrlrni_h_w */

            case 3:
              if (!
#line 3081 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1489; /* lsx_vsrlrni_b_h */

            default:
              return -1;
            }

        case 145:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3092 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1490; /* lsx_vssrlni_d_q */

            case 1:
              if (!
#line 3092 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1491; /* lsx_vssrlni_w_d */

            case 2:
              if (!
#line 3092 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1492; /* lsx_vssrlni_h_w */

            case 3:
              if (!
#line 3092 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1493; /* lsx_vssrlni_b_h */

            default:
              return -1;
            }

        case 146:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3103 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1494; /* lsx_vssrlni_du_q */

            case 1:
              if (!
#line 3103 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1495; /* lsx_vssrlni_wu_d */

            case 2:
              if (!
#line 3103 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1496; /* lsx_vssrlni_hu_w */

            case 3:
              if (!
#line 3103 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1497; /* lsx_vssrlni_bu_h */

            default:
              return -1;
            }

        case 147:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3114 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1498; /* lsx_vssrlrni_d_q */

            case 1:
              if (!
#line 3114 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1499; /* lsx_vssrlrni_w_d */

            case 2:
              if (!
#line 3114 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1500; /* lsx_vssrlrni_h_w */

            case 3:
              if (!
#line 3114 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1501; /* lsx_vssrlrni_b_h */

            default:
              return -1;
            }

        case 148:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3125 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1502; /* lsx_vssrlrni_du_q */

            case 1:
              if (!
#line 3125 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1503; /* lsx_vssrlrni_wu_d */

            case 2:
              if (!
#line 3125 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1504; /* lsx_vssrlrni_hu_w */

            case 3:
              if (!
#line 3125 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1505; /* lsx_vssrlrni_bu_h */

            default:
              return -1;
            }

        case 149:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3136 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1506; /* lsx_vsrani_d_q */

            case 1:
              if (!
#line 3136 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1507; /* lsx_vsrani_w_d */

            case 2:
              if (!
#line 3136 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1508; /* lsx_vsrani_h_w */

            case 3:
              if (!
#line 3136 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1509; /* lsx_vsrani_b_h */

            default:
              return -1;
            }

        case 150:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3147 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1510; /* lsx_vsrarni_d_q */

            case 1:
              if (!
#line 3147 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1511; /* lsx_vsrarni_w_d */

            case 2:
              if (!
#line 3147 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1512; /* lsx_vsrarni_h_w */

            case 3:
              if (!
#line 3147 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1513; /* lsx_vsrarni_b_h */

            default:
              return -1;
            }

        case 151:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3158 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1514; /* lsx_vssrani_d_q */

            case 1:
              if (!
#line 3158 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1515; /* lsx_vssrani_w_d */

            case 2:
              if (!
#line 3158 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1516; /* lsx_vssrani_h_w */

            case 3:
              if (!
#line 3158 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1517; /* lsx_vssrani_b_h */

            default:
              return -1;
            }

        case 152:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3169 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1518; /* lsx_vssrani_du_q */

            case 1:
              if (!
#line 3169 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1519; /* lsx_vssrani_wu_d */

            case 2:
              if (!
#line 3169 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1520; /* lsx_vssrani_hu_w */

            case 3:
              if (!
#line 3169 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1521; /* lsx_vssrani_bu_h */

            default:
              return -1;
            }

        case 153:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3180 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1522; /* lsx_vssrarni_d_q */

            case 1:
              if (!
#line 3180 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1523; /* lsx_vssrarni_w_d */

            case 2:
              if (!
#line 3180 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1524; /* lsx_vssrarni_h_w */

            case 3:
              if (!
#line 3180 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1525; /* lsx_vssrarni_b_h */

            default:
              return -1;
            }

        case 154:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3191 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1526; /* lsx_vssrarni_du_q */

            case 1:
              if (!
#line 3191 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1527; /* lsx_vssrarni_wu_d */

            case 2:
              if (!
#line 3191 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1528; /* lsx_vssrarni_hu_w */

            case 3:
              if (!
#line 3191 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1529; /* lsx_vssrarni_bu_h */

            default:
              return -1;
            }

        case 155:
          if (pattern143 (x2, 
E_V4SImode) != 0
              || !
#line 3202 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1530; /* lsx_vpermi_w */

        case 226:
          return recog_67 (x1, insn, pnum_clobbers);

        case 256:
          return recog_66 (x1, insn, pnum_clobbers);

        case 257:
          switch (GET_MODE (operands[0]))
            {
            case E_V16HImode:
              if (pattern161 (x2, 
E_V16HImode, 
E_HImode) != 0
                  || !const_exp_16_operand (operands[3], E_VOIDmode)
                  || !
#line 591 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1566; /* lasx_xvinsgr2vr_v8hi_internal */

            case E_V32QImode:
              if (pattern161 (x2, 
E_V32QImode, 
E_QImode) != 0
                  || !const_exp_32_operand (operands[3], E_VOIDmode)
                  || !
#line 591 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1567; /* lasx_xvinsgr2vr_v16qi_internal */

            default:
              return -1;
            }

        case 182:
          return recog_68 (x1, insn, pnum_clobbers);

        case 183:
          if (pattern145 (x2, 
E_V32QImode) != 0
              || !
#line 2080 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1870; /* lasx_xvshuf_b */

        case 198:
          if (!const_uimm5_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16HImode:
              if (pattern58 (x2, 
E_V16HImode) != 0
                  || !
#line 2625 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1991; /* lasx_xvfrstpi_h */

            case E_V32QImode:
              if (pattern58 (x2, 
E_V32QImode) != 0
                  || !
#line 2625 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1992; /* lasx_xvfrstpi_b */

            default:
              return -1;
            }

        case 199:
          switch (GET_MODE (operands[0]))
            {
            case E_V16HImode:
              if (pattern160 (x2, 
E_V16HImode) != 0
                  || !
#line 2636 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1993; /* lasx_xvfrstp_h */

            case E_V32QImode:
              if (pattern160 (x2, 
E_V32QImode) != 0
                  || !
#line 2636 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1994; /* lasx_xvfrstp_b */

            default:
              return -1;
            }

        case 200:
          if (pattern143 (x2, 
E_V4DImode) != 0
              || !
#line 2647 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1995; /* lasx_xvshuf4i_d */

        case 203:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 2678 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2004; /* lasx_xvextrins_d */

            case 1:
              if (!
#line 2678 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2005; /* lasx_xvextrins_w */

            case 2:
              if (!
#line 2678 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2006; /* lasx_xvextrins_h */

            case 3:
              if (!
#line 2678 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2007; /* lasx_xvextrins_b */

            default:
              return -1;
            }

        case 236:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3249 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2080; /* lasx_xvsrlni_d_q */

            case 1:
              if (!
#line 3249 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2081; /* lasx_xvsrlni_w_d */

            case 2:
              if (!
#line 3249 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2082; /* lasx_xvsrlni_h_w */

            case 3:
              if (!
#line 3249 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2083; /* lasx_xvsrlni_b_h */

            default:
              return -1;
            }

        case 237:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3260 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2084; /* lasx_xvsrlrni_d_q */

            case 1:
              if (!
#line 3260 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2085; /* lasx_xvsrlrni_w_d */

            case 2:
              if (!
#line 3260 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2086; /* lasx_xvsrlrni_h_w */

            case 3:
              if (!
#line 3260 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2087; /* lasx_xvsrlrni_b_h */

            default:
              return -1;
            }

        case 238:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3271 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2088; /* lasx_xvssrlni_d_q */

            case 1:
              if (!
#line 3271 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2089; /* lasx_xvssrlni_w_d */

            case 2:
              if (!
#line 3271 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2090; /* lasx_xvssrlni_h_w */

            case 3:
              if (!
#line 3271 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2091; /* lasx_xvssrlni_b_h */

            default:
              return -1;
            }

        case 239:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3282 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2092; /* lasx_xvssrlni_du_q */

            case 1:
              if (!
#line 3282 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2093; /* lasx_xvssrlni_wu_d */

            case 2:
              if (!
#line 3282 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2094; /* lasx_xvssrlni_hu_w */

            case 3:
              if (!
#line 3282 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2095; /* lasx_xvssrlni_bu_h */

            default:
              return -1;
            }

        case 240:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3293 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2096; /* lasx_xvssrlrni_d_q */

            case 1:
              if (!
#line 3293 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2097; /* lasx_xvssrlrni_w_d */

            case 2:
              if (!
#line 3293 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2098; /* lasx_xvssrlrni_h_w */

            case 3:
              if (!
#line 3293 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2099; /* lasx_xvssrlrni_b_h */

            default:
              return -1;
            }

        case 241:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3304 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2100; /* lasx_xvssrlrni_du_q */

            case 1:
              if (!
#line 3304 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2101; /* lasx_xvssrlrni_wu_d */

            case 2:
              if (!
#line 3304 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2102; /* lasx_xvssrlrni_hu_w */

            case 3:
              if (!
#line 3304 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2103; /* lasx_xvssrlrni_bu_h */

            default:
              return -1;
            }

        case 242:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3315 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2104; /* lasx_xvsrani_d_q */

            case 1:
              if (!
#line 3315 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2105; /* lasx_xvsrani_w_d */

            case 2:
              if (!
#line 3315 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2106; /* lasx_xvsrani_h_w */

            case 3:
              if (!
#line 3315 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2107; /* lasx_xvsrani_b_h */

            default:
              return -1;
            }

        case 243:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3326 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2108; /* lasx_xvsrarni_d_q */

            case 1:
              if (!
#line 3326 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2109; /* lasx_xvsrarni_w_d */

            case 2:
              if (!
#line 3326 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2110; /* lasx_xvsrarni_h_w */

            case 3:
              if (!
#line 3326 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2111; /* lasx_xvsrarni_b_h */

            default:
              return -1;
            }

        case 244:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3337 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2112; /* lasx_xvssrani_d_q */

            case 1:
              if (!
#line 3337 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2113; /* lasx_xvssrani_w_d */

            case 2:
              if (!
#line 3337 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2114; /* lasx_xvssrani_h_w */

            case 3:
              if (!
#line 3337 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2115; /* lasx_xvssrani_b_h */

            default:
              return -1;
            }

        case 245:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3348 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2116; /* lasx_xvssrani_du_q */

            case 1:
              if (!
#line 3348 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2117; /* lasx_xvssrani_wu_d */

            case 2:
              if (!
#line 3348 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2118; /* lasx_xvssrani_hu_w */

            case 3:
              if (!
#line 3348 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2119; /* lasx_xvssrani_bu_h */

            default:
              return -1;
            }

        case 246:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3359 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2120; /* lasx_xvssrarni_d_q */

            case 1:
              if (!
#line 3359 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2121; /* lasx_xvssrarni_w_d */

            case 2:
              if (!
#line 3359 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2122; /* lasx_xvssrarni_h_w */

            case 3:
              if (!
#line 3359 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2123; /* lasx_xvssrarni_b_h */

            default:
              return -1;
            }

        case 247:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3370 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2124; /* lasx_xvssrarni_du_q */

            case 1:
              if (!
#line 3370 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2125; /* lasx_xvssrarni_wu_d */

            case 2:
              if (!
#line 3370 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2126; /* lasx_xvssrarni_hu_w */

            case 3:
              if (!
#line 3370 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2127; /* lasx_xvssrarni_bu_h */

            default:
              return -1;
            }

        case 248:
          if (!const_uimm8_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SImode:
              if (pattern58 (x2, 
E_V8SImode) != 0
                  || !
#line 3385 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2128; /* lasx_xvpermi_w */

            case E_V8SFmode:
              if (pattern58 (x2, 
E_V8SFmode) != 0
                  || !
#line 3385 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2129; /* lasx_xvpermi_w_f */

            default:
              return -1;
            }

        case 249:
          switch (GET_MODE (operands[0]))
            {
            case E_V4DImode:
              if (pattern162 (x2, 
E_V4DImode) != 0
                  || !
#line 3492 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2142; /* lasx_xvinsve0_d */

            case E_V4DFmode:
              if (pattern162 (x2, 
E_V4DFmode) != 0
                  || !
#line 3492 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2143; /* lasx_xvinsve0_d_f */

            case E_V8SImode:
              if (pattern163 (x2, 
E_V8SImode) != 0
                  || !
#line 3492 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2144; /* lasx_xvinsve0_w */

            case E_V8SFmode:
              if (pattern163 (x2, 
E_V8SFmode) != 0
                  || !
#line 3492 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2145; /* lasx_xvinsve0_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern10 (x1))
    {
    case 0:
      return 244; /* *lshrsi3 */

    case 1:
      if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 247; /* *lshrdi3 */

    case 2:
      if (const_uimm6_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 629; /* lshrv2di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V2DImode)
          || !
#line 723 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1026; /* vlshrv2di3 */

    case 3:
      if (const_uimm5_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 633; /* lshrv4si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4SImode)
          || !
#line 723 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1027; /* vlshrv4si3 */

    case 4:
      if (const_uimm4_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 637; /* lshrv8hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8HImode)
          || !
#line 723 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1028; /* vlshrv8hi3 */

    case 5:
      if (const_uimm3_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 641; /* lshrv16qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16QImode)
          || !
#line 723 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1029; /* vlshrv16qi3 */

    case 6:
      if (const_uimm6_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 645; /* lshrv4di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4DImode)
          || !
#line 862 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1628; /* vlshrv4di3 */

    case 7:
      if (const_uimm5_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 649; /* lshrv8si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8SImode)
          || !
#line 862 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1629; /* vlshrv8si3 */

    case 8:
      if (const_uimm4_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 653; /* lshrv16hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16HImode)
          || !
#line 862 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1630; /* vlshrv16hi3 */

    case 9:
      if (const_uimm3_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 657; /* lshrv32qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V32QImode)
          || !
#line 862 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1631; /* vlshrv32qi3 */

    case 10:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 920; /* simd_lshr_imm_round_v2di */

    case 11:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 922; /* simd_lshr_imm_round_v4si */

    case 12:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 924; /* simd_lshr_imm_round_v8hi */

    case 13:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 926; /* simd_lshr_imm_round_v16qi */

    case 14:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 928; /* simd_lshr_imm_round_v4di */

    case 15:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 930; /* simd_lshr_imm_round_v8si */

    case 16:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 932; /* simd_lshr_imm_round_v16hi */

    case 17:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 934; /* simd_lshr_imm_round_v32qi */

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      switch (GET_CODE (x3))
        {
        case NE:
          res = recog_72 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case EQ:
          res = recog_73 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x3;
      if (!equality_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (register_operand (operands[2], E_FCCmode))
        {
          x6 = XEXP (x3, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == PC)
                    {
                      x9 = XEXP (x7, 0);
                      operands[0] = x9;
                      if (
#line 3293 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                        return 275; /* *branch_fp_FCCmode */
                    }
                  break;

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == LABEL_REF)
                    {
                      x10 = XEXP (x8, 0);
                      operands[0] = x10;
                      if (
#line 3309 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                        return 276; /* *branch_fp_inverted_FCCmode */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      switch (pattern148 (x2))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 281; /* branch_equalitysi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 282; /* branch_equalitydi */

        case 2:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 283; /* *branch_equalitysi_inverted */

        case 3:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 284; /* *branch_equalitydi_inverted */

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) == ABS)
        {
          res = recog_74 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!order_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      switch (pattern148 (x2))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 277; /* *branch_ordersi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 278; /* *branch_orderdi */

        case 2:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 279; /* *branch_ordersi_inverted */

        case 3:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 280; /* *branch_orderdi_inverted */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 3:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x5;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case UNSPEC:
              if (pattern106 (x6) != 0
                  || !register_operand (operands[0], E_DImode)
                  || !symbolic_off64_or_reg_operand (operands[1], E_DImode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 2240 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_CMODEL_EXTREME))
                return -1;
              return 154; /* movdi_symbolic_off64 */

            case SET:
              x8 = XEXP (x6, 1);
              if (GET_CODE (x8) != UNSPEC_VOLATILE)
                return -1;
              x9 = XEXP (x6, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              switch (XVECLEN (x8, 0))
                {
                case 3:
                  if (XINT (x8, 1) != 41)
                    return -1;
                  x10 = XVECEXP (x8, 0, 0);
                  operands[2] = x10;
                  x11 = XVECEXP (x8, 0, 1);
                  operands[3] = x11;
                  x12 = XVECEXP (x8, 0, 2);
                  operands[4] = x12;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  operands[5] = x7;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern215 (x8, 
E_SImode) != 0)
                        return -1;
                      return 521; /* atomic_cas_value_strongsi */

                    case E_DImode:
                      if (pattern215 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 522; /* atomic_cas_value_strongdi */

                    default:
                      return -1;
                    }

                case 5:
                  x10 = XVECEXP (x8, 0, 0);
                  operands[2] = x10;
                  x11 = XVECEXP (x8, 0, 1);
                  operands[3] = x11;
                  x12 = XVECEXP (x8, 0, 2);
                  operands[4] = x12;
                  x13 = XVECEXP (x8, 0, 3);
                  operands[5] = x13;
                  x14 = XVECEXP (x8, 0, 4);
                  operands[6] = x14;
                  if (!const_int_operand (operands[6], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  operands[7] = x7;
                  switch (XINT (x8, 1))
                    {
                    case 41:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern217 (x8, 
E_SImode) != 0)
                            return -1;
                          return 527; /* atomic_cas_value_cmp_and_7_si */

                        case E_DImode:
                          if (pattern217 (x8, 
E_DImode) != 0
                              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 528; /* atomic_cas_value_cmp_and_7_di */

                        default:
                          return -1;
                        }

                    case 49:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern217 (x8, 
E_SImode) != 0)
                            return -1;
                          return 541; /* atomic_cas_value_exchange_7_si */

                        case E_DImode:
                          if (pattern217 (x8, 
E_DImode) != 0
                              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 542; /* atomic_cas_value_exchange_7_di */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CALL:
          x15 = XEXP (x5, 0);
          if (GET_CODE (x15) != MEM)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CALL)
            return -1;
          x16 = XEXP (x8, 0);
          if (GET_CODE (x16) != MEM)
            return -1;
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 1
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 0);
          if (!register_operand (x9, E_VOIDmode))
            return -1;
          x17 = XEXP (x15, 0);
          switch (GET_CODE (x17))
            {
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
              operands[1] = x17;
              if (!call_insn_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x15) != E_SImode)
                return -1;
              x18 = XEXP (x5, 1);
              operands[2] = x18;
              operands[3] = x9;
              if (GET_MODE (x16) != E_SImode)
                return -1;
              x19 = XEXP (x16, 0);
              if (!rtx_equal_p (x19, operands[1]))
                return -1;
              x20 = XEXP (x8, 1);
              if (!rtx_equal_p (x20, operands[2]))
                return -1;
              return 369; /* call_value_multiple_internal */

            case UNSPEC:
              if (XVECLEN (x17, 0) != 2
                  || XINT (x17, 1) != 37)
                return -1;
              x19 = XEXP (x16, 0);
              if (GET_CODE (x19) != UNSPEC
                  || XVECLEN (x19, 0) != 2
                  || XINT (x19, 1) != 37)
                return -1;
              x21 = XVECEXP (x17, 0, 0);
              operands[1] = x21;
              x22 = XVECEXP (x17, 0, 1);
              operands[2] = x22;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              operands[4] = x9;
              x23 = XVECEXP (x19, 0, 0);
              if (!rtx_equal_p (x23, operands[1]))
                return -1;
              x24 = XVECEXP (x19, 0, 1);
              if (!rtx_equal_p (x24, operands[2]))
                return -1;
              x20 = XEXP (x8, 1);
              if (!rtx_equal_p (x20, operands[3]))
                return -1;
              switch (GET_MODE (x15))
                {
                case E_SImode:
                  if (pattern220 (x1, 
E_SImode) != 0
                      || !(
#line 4114 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  return 370; /* call_value_multiple_internal_1si */

                case E_DImode:
                  if (pattern220 (x1, 
E_DImode) != 0
                      || !(
#line 4114 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  return 371; /* call_value_multiple_internal_1di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SET:
          return recog_133 (x1, insn, pnum_clobbers);

        case UNSPEC_VOLATILE:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern19 (x6) != 0)
            return -1;
          switch (XVECLEN (x2, 0))
            {
            case 1:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              x25 = XVECEXP (x2, 0, 0);
              operands[0] = x25;
              if (!const_uimm15_operand (operands[0], E_VOIDmode))
                return -1;
              switch (XINT (x2, 1))
                {
                case 2:
                  return 215; /* loongarch_ibar */

                case 1:
                  return 216; /* loongarch_dbar */

                case 18:
                  return 218; /* loongarch_syscall */

                case 19:
                  return 219; /* loongarch_break */

                default:
                  return -1;
                }

            case 2:
              x25 = XVECEXP (x2, 0, 0);
              operands[0] = x25;
              x26 = XVECEXP (x2, 0, 1);
              operands[1] = x26;
              switch (XINT (x2, 1))
                {
                case 7:
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode))
                        return -1;
                      return 232; /* loongarch_iocsrwr_b */

                    case E_HImode:
                      if (!register_operand (operands[0], E_HImode))
                        return -1;
                      return 233; /* loongarch_iocsrwr_h */

                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      return 234; /* loongarch_iocsrwr_w */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 235; /* loongarch_iocsrwr_d */

                    default:
                      return -1;
                    }

                case 10:
                  if (!const_uimm5_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                        return -1;
                      return 240; /* loongarch_ldpte_w */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 241; /* loongarch_ldpte_d */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 3:
              x25 = XVECEXP (x2, 0, 0);
              operands[0] = x25;
              x26 = XVECEXP (x2, 0, 1);
              operands[1] = x26;
              x27 = XVECEXP (x2, 0, 2);
              operands[2] = x27;
              switch (XINT (x2, 1))
                {
                case 8:
                  if (!const_uimm5_operand (operands[0], E_VOIDmode)
                      || !const_imm12_operand (operands[2], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_SImode:
                      if (!register_operand (operands[1], E_SImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                        return -1;
                      return 236; /* loongarch_cacop_w */

                    case E_DImode:
                      if (!register_operand (operands[1], E_DImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 237; /* loongarch_cacop_d */

                    default:
                      return -1;
                    }

                case 9:
                  if (!const_uimm5_operand (operands[2], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode)
                          || !register_operand (operands[1], E_SImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                        return -1;
                      return 238; /* loongarch_lddir_w */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !register_operand (operands[1], E_DImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 239; /* loongarch_lddir_d */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case RETURN:
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case USE:
              x9 = XEXP (x6, 0);
              operands[0] = x9;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              return 348; /* return_internal */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 11)
                return -1;
              x28 = XVECEXP (x6, 0, 0);
              if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 350; /* loongarch_ertn */

            default:
              return -1;
            }

        case SIMPLE_RETURN:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x9 = XEXP (x6, 0);
          operands[0] = x9;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          return 349; /* simple_return_internal */

        case UNSPEC:
          if (XVECLEN (x2, 0) != 1
              || XINT (x2, 1) != 14)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x25 = XVECEXP (x2, 0, 0);
          operands[0] = x25;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !scratch_operand (operands[1], E_SImode)
                  || !
#line 3717 "../../gcc/config/loongarch/loongarch.md"
(! TARGET_64BIT))
                return -1;
              return 352; /* eh_set_ra_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !scratch_operand (operands[1], E_DImode)
                  || !
#line 3723 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 353; /* eh_set_ra_di */

            default:
              return -1;
            }

        case CALL:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern99 (x6) != 0)
            return -1;
          x29 = XEXP (x4, 0);
          switch (GET_CODE (x29))
            {
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
              operands[0] = x29;
              if (!call_insn_operand (operands[0], E_VOIDmode)
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              return 363; /* call_internal */

            case LO_SUM:
              x30 = XEXP (x29, 0);
              operands[0] = x30;
              x31 = XEXP (x29, 1);
              operands[1] = x31;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  if (GET_MODE (x29) != E_SImode
                      || !register_operand (operands[0], E_SImode)
                      || !symbolic_operand (operands[1], E_SImode)
                      || !(
#line 3990 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  return 364; /* call_internal_1si */

                case E_DImode:
                  if (GET_MODE (x29) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || !symbolic_operand (operands[1], E_DImode)
                      || !(
#line 3990 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  return 365; /* call_internal_1di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 10:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 18)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 4
          || pattern155 (x1) != 0)
        return -1;
      x32 = XVECEXP (x5, 0, 0);
      operands[0] = x32;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !symbolic_operand (operands[0], E_SImode)
              || !(
#line 2748 "../../gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return -1;
          return 210; /* got_load_tls_descsi */

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !symbolic_operand (operands[0], E_DImode)
              || !(
#line 2748 "../../gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return -1;
          return 211; /* got_load_tls_descdi */

        default:
          return -1;
        }

    case 11:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 19
          || GET_MODE (x5) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 4
          || GET_MODE (x4) != E_DImode
          || pattern155 (x1) != 0)
        return -1;
      x33 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x33) != CLOBBER)
        return -1;
      x32 = XVECEXP (x5, 0, 0);
      operands[0] = x32;
      if (!symbolic_operand (operands[0], E_DImode))
        return -1;
      x34 = XEXP (x33, 0);
      operands[1] = x34;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 2776 "../../gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC && TARGET_CMODEL_EXTREME))
        return -1;
      return 212; /* got_load_tls_desc_off64 */

    case 4:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != UNSPEC_VOLATILE
          || XVECLEN (x8, 0) != 5)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x35 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x35) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x10 = XVECEXP (x8, 0, 0);
      operands[2] = x10;
      x11 = XVECEXP (x8, 0, 1);
      operands[3] = x11;
      x12 = XVECEXP (x8, 0, 2);
      operands[4] = x12;
      x13 = XVECEXP (x8, 0, 3);
      operands[5] = x13;
      x14 = XVECEXP (x8, 0, 4);
      operands[6] = x14;
      if (!const_int_operand (operands[6], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[7] = x7;
      x36 = XEXP (x35, 0);
      operands[8] = x36;
      x9 = XEXP (x6, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (XINT (x8, 1))
        {
        case 42:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 529; /* atomic_cas_value_add_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 530; /* atomic_cas_value_add_7_di */

            default:
              return -1;
            }

        case 43:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 531; /* atomic_cas_value_sub_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 532; /* atomic_cas_value_sub_7_di */

            default:
              return -1;
            }

        case 44:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 533; /* atomic_cas_value_and_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 534; /* atomic_cas_value_and_7_di */

            default:
              return -1;
            }

        case 45:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 535; /* atomic_cas_value_xor_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 536; /* atomic_cas_value_xor_7_di */

            default:
              return -1;
            }

        case 46:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 537; /* atomic_cas_value_or_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 538; /* atomic_cas_value_or_7_di */

            default:
              return -1;
            }

        case 47:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 539; /* atomic_cas_value_nand_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 540; /* atomic_cas_value_nand_7_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
