/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return pattern5 (x3); /* [-1, 9] */

    case PLUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern6 (x3, 
E_V2DImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern7 (x3, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern8 (x3, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V16QImode:
          if (pattern9 (x3, 
E_V16QImode) != 0)
            return -1;
          return 13;

        case E_V4DImode:
          if (pattern6 (x3, 
E_V4DImode) != 0)
            return -1;
          return 14;

        case E_V8SImode:
          if (pattern7 (x3, 
E_V8SImode) != 0)
            return -1;
          return 15;

        case E_V16HImode:
          if (pattern8 (x3, 
E_V16HImode) != 0)
            return -1;
          return 16;

        case E_V32QImode:
          if (pattern9 (x3, 
E_V32QImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !const_uimm3_operand (operands[2], E_VOIDmode))
                return -1;
              return 0;

            case E_QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !const_uimm4_operand (operands[2], E_VOIDmode))
                return -1;
              return 1;

            case E_SImode:
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !const_0_to_3_operand (operands[2], E_VOIDmode))
                    return -1;
                  return 2;

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode)
                      || !const_0_to_7_operand (operands[2], E_VOIDmode))
                    return -1;
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SFmode:
          if (pattern36 (x1, 
E_V4SFmode, 
E_SFmode) != 0)
            return -1;
          return 4;

        case E_DImode:
          if (pattern36 (x1, 
E_V4DImode, 
E_DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 8LL:
          if (XWINT (x6, 0) != 9LL
              || XWINT (x7, 0) != 10LL
              || XWINT (x8, 0) != 11LL
              || pattern38 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case 0LL:
          if (XWINT (x6, 0) != 1LL
              || XWINT (x7, 0) != 2LL
              || XWINT (x8, 0) != 3LL
              || XWINT (x9, 0) != 4LL
              || XWINT (x10, 0) != 5LL
              || XWINT (x11, 0) != 6LL
              || XWINT (x12, 0) != 7LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern37 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
                return -1;
              return 7;

            case E_V8SImode:
              if (!register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x1) != E_V8SImode)
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V16HImode))
                    return -1;
                  return 8;

                case E_V8QImode:
                  if (!register_operand (operands[1], E_V32QImode))
                    return -1;
                  return 9;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4LL:
          if (XWINT (x6, 0) != 5LL
              || XWINT (x7, 0) != 6LL
              || XWINT (x8, 0) != 7LL
              || pattern38 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 4LL:
          if (XWINT (x6, 0) != 5LL
              || pattern39 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case 0LL:
          if (XWINT (x6, 0) != 1LL
              || XWINT (x7, 0) != 2LL
              || XWINT (x8, 0) != 3LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern37 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
                return -1;
              return 12;

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x1) != E_V4DImode)
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  return 13;

                case E_V4HImode:
                  if (!register_operand (operands[1], E_V16HImode))
                    return -1;
                  return 14;

                case E_V4QImode:
                  if (!register_operand (operands[1], E_V32QImode))
                    return -1;
                  return 15;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2LL:
          if (XWINT (x6, 0) != 3LL
              || pattern39 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 16;

        default:
          return -1;
        }

    case 2:
      res = pattern41 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case 16:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x3, 0, 8);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x14 = XVECEXP (x3, 0, 9);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x3, 0, 10);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x3, 0, 11);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x3, 0, 12);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x3, 0, 13);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x3, 0, 14);
      if (GET_CODE (x19) != CONST_INT)
        return -1;
      x20 = XVECEXP (x3, 0, 15);
      if (GET_CODE (x20) != CONST_INT
          || !register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0LL:
          if (XWINT (x6, 0) != 1LL
              || XWINT (x7, 0) != 2LL
              || XWINT (x8, 0) != 3LL
              || XWINT (x9, 0) != 4LL
              || XWINT (x10, 0) != 5LL
              || XWINT (x11, 0) != 6LL
              || XWINT (x12, 0) != 7LL
              || XWINT (x13, 0) != 8LL
              || XWINT (x14, 0) != 9LL
              || XWINT (x15, 0) != 10LL
              || XWINT (x16, 0) != 11LL
              || XWINT (x17, 0) != 12LL
              || XWINT (x18, 0) != 13LL
              || XWINT (x19, 0) != 14LL
              || XWINT (x20, 0) != 15LL)
            return -1;
          return 19;

        case 8LL:
          if (XWINT (x6, 0) != 9LL
              || XWINT (x7, 0) != 10LL
              || XWINT (x8, 0) != 11LL
              || XWINT (x9, 0) != 12LL
              || XWINT (x10, 0) != 13LL
              || XWINT (x11, 0) != 14LL
              || XWINT (x12, 0) != 15LL
              || XWINT (x13, 0) != 24LL
              || XWINT (x14, 0) != 25LL
              || XWINT (x15, 0) != 26LL
              || XWINT (x16, 0) != 27LL
              || XWINT (x17, 0) != 28LL
              || XWINT (x18, 0) != 29LL
              || XWINT (x19, 0) != 30LL
              || XWINT (x20, 0) != 31LL)
            return -1;
          return 20;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern183 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aq12d_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern191 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern200 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[4], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1)
      || !scratch_operand (operands[7], i1)
      || !scratch_operand (operands[8], i1))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 561; /* lsx_vfrint_d */

    case 1:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 566; /* lsx_vfrint_s */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 571; /* lasx_xvfrint_d */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 576; /* lasx_xvfrint_s */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern139 (x3, 
E_V2DImode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1263; /* lsx_vreplvei_mirror_d */

    case E_V4SImode:
      if (pattern140 (x3, 
E_V4SImode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1264; /* lsx_vreplvei_mirror_w */

    case E_V8HImode:
      if (pattern66 (x3, 
E_V8HImode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1265; /* lsx_vreplvei_mirror_h */

    case E_V16QImode:
      if (pattern65 (x3, 
E_V16QImode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1266; /* lsx_vreplvei_mirror_b */

    case E_V2DFmode:
      if (pattern139 (x3, 
E_V2DFmode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1267; /* lsx_vreplvei_mirror_d_f */

    case E_V4SFmode:
      if (pattern140 (x3, 
E_V4SFmode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1268; /* lsx_vreplvei_mirror_w_f */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm5_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern110 (x3))
    {
    case 0:
      if (!
#line 2257 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1386; /* lsx_vbsll_d */

    case 1:
      if (!
#line 2257 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1387; /* lsx_vbsll_w */

    case 2:
      if (!
#line 2257 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1388; /* lsx_vbsll_h */

    case 3:
      if (!
#line 2257 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1389; /* lsx_vbsll_b */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (!
#line 2667 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2000; /* lasx_xvbsll_d */

    case 1:
      if (!
#line 2667 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2001; /* lasx_xvbsll_w */

    case 2:
      if (!
#line 2667 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2002; /* lasx_xvbsll_h */

    case 3:
      if (!
#line 2667 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2003; /* lasx_xvbsll_b */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1180 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1713; /* lasx_xvbitset_d */

    case 1:
      if (!
#line 1180 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1714; /* lasx_xvbitset_w */

    case 2:
      if (!
#line 1180 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1715; /* lasx_xvbitset_h */

    case 3:
      if (!
#line 1180 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1716; /* lasx_xvbitset_b */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2287 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1398; /* lsx_vsigncov_d */

    case 1:
      if (!
#line 2287 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1399; /* lsx_vsigncov_w */

    case 2:
      if (!
#line 2287 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1400; /* lsx_vsigncov_h */

    case 3:
      if (!
#line 2287 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1401; /* lsx_vsigncov_b */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 996 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1096; /* lsx_vbitrev_d */

    case 1:
      if (!
#line 996 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1097; /* lsx_vbitrev_w */

    case 2:
      if (!
#line 996 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1098; /* lsx_vbitrev_h */

    case 3:
      if (!
#line 996 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1099; /* lsx_vbitrev_b */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1558; /* lasx_vecinit_merge_v4di */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1559; /* lasx_vecinit_merge_v8si */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V8HImode, 
E_V16HImode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1560; /* lasx_vecinit_merge_v16hi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1561; /* lasx_vecinit_merge_v32qi */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1562; /* lasx_vecinit_merge_v4df */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1563; /* lasx_vecinit_merge_v8sf */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x5, 0, 4);
  if (!const_4_to_7_operand (x7, E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && pattern207 (x5) == 0
          && 
#line 2007 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])))
        return 1847; /* lasx_xvshuf4i_w_1 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      operands[3] = x7;
      x8 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XVECEXP (x5, 0, 2);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x5, 0, 3);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (!rtx_equal_p (x13, operands[3])
          || !
#line 2142 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ((INTVAL (operands[3]) - INTVAL (operands[2])) == 4)))
        return -1;
      return 1879; /* lasx_xvrepl128vei_w_internal */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || pattern207 (x5) != 0
          || !
#line 2007 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])))
        return -1;
      return 1848; /* lasx_xvshuf4i_w_f_1 */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern154 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 0LL:
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 16LL:
          x6 = XVECEXP (x3, 0, 2);
          switch (XWINT (x6, 0))
            {
            case 2LL:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 18LL)
                return -1;
              x8 = XVECEXP (x3, 0, 4);
              if (XWINT (x8, 0) != 4LL)
                return -1;
              x9 = XVECEXP (x3, 0, 5);
              if (XWINT (x9, 0) != 20LL)
                return -1;
              x10 = XVECEXP (x3, 0, 6);
              if (XWINT (x10, 0) != 6LL)
                return -1;
              x11 = XVECEXP (x3, 0, 7);
              if (XWINT (x11, 0) != 22LL)
                return -1;
              x12 = XVECEXP (x3, 0, 8);
              if (XWINT (x12, 0) != 8LL)
                return -1;
              x13 = XVECEXP (x3, 0, 9);
              if (XWINT (x13, 0) != 24LL)
                return -1;
              x14 = XVECEXP (x3, 0, 10);
              if (XWINT (x14, 0) != 10LL)
                return -1;
              x15 = XVECEXP (x3, 0, 11);
              if (XWINT (x15, 0) != 26LL)
                return -1;
              x16 = XVECEXP (x3, 0, 12);
              if (XWINT (x16, 0) != 12LL)
                return -1;
              x17 = XVECEXP (x3, 0, 13);
              if (XWINT (x17, 0) != 28LL)
                return -1;
              x18 = XVECEXP (x3, 0, 14);
              if (XWINT (x18, 0) != 14LL)
                return -1;
              x19 = XVECEXP (x3, 0, 15);
              if (XWINT (x19, 0) != 30LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern205 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                      || !
#line 1300 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1171; /* lsx_vpackev_b */

                case E_V16HImode:
                  if (pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                      || !
#line 1439 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1776; /* lasx_xvpackev_h */

                default:
                  return -1;
                }

            case 1LL:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 17LL)
                return -1;
              x8 = XVECEXP (x3, 0, 4);
              if (XWINT (x8, 0) != 2LL)
                return -1;
              x9 = XVECEXP (x3, 0, 5);
              if (XWINT (x9, 0) != 18LL)
                return -1;
              x10 = XVECEXP (x3, 0, 6);
              if (XWINT (x10, 0) != 3LL)
                return -1;
              x11 = XVECEXP (x3, 0, 7);
              if (XWINT (x11, 0) != 19LL)
                return -1;
              x12 = XVECEXP (x3, 0, 8);
              switch (XWINT (x12, 0))
                {
                case 4LL:
                  x13 = XVECEXP (x3, 0, 9);
                  if (XWINT (x13, 0) != 20LL)
                    return -1;
                  x14 = XVECEXP (x3, 0, 10);
                  if (XWINT (x14, 0) != 5LL)
                    return -1;
                  x15 = XVECEXP (x3, 0, 11);
                  if (XWINT (x15, 0) != 21LL)
                    return -1;
                  x16 = XVECEXP (x3, 0, 12);
                  if (XWINT (x16, 0) != 6LL)
                    return -1;
                  x17 = XVECEXP (x3, 0, 13);
                  if (XWINT (x17, 0) != 22LL)
                    return -1;
                  x18 = XVECEXP (x3, 0, 14);
                  if (XWINT (x18, 0) != 7LL)
                    return -1;
                  x19 = XVECEXP (x3, 0, 15);
                  if (XWINT (x19, 0) != 23LL
                      || pattern205 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                      || !
#line 1483 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1185; /* lsx_vilvl_b */

                case 8LL:
                  x13 = XVECEXP (x3, 0, 9);
                  if (XWINT (x13, 0) != 24LL)
                    return -1;
                  x14 = XVECEXP (x3, 0, 10);
                  if (XWINT (x14, 0) != 9LL)
                    return -1;
                  x15 = XVECEXP (x3, 0, 11);
                  if (XWINT (x15, 0) != 25LL)
                    return -1;
                  x16 = XVECEXP (x3, 0, 12);
                  if (XWINT (x16, 0) != 10LL)
                    return -1;
                  x17 = XVECEXP (x3, 0, 13);
                  if (XWINT (x17, 0) != 26LL)
                    return -1;
                  x18 = XVECEXP (x3, 0, 14);
                  if (XWINT (x18, 0) != 11LL)
                    return -1;
                  x19 = XVECEXP (x3, 0, 15);
                  if (XWINT (x19, 0) != 27LL
                      || pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                      || !
#line 1672 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1790; /* lasx_xvilvl_h */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2LL:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 4LL)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 6LL)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 16LL)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 18LL)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 20LL)
            return -1;
          x11 = XVECEXP (x3, 0, 7);
          if (XWINT (x11, 0) != 22LL)
            return -1;
          x12 = XVECEXP (x3, 0, 8);
          if (XWINT (x12, 0) != 8LL)
            return -1;
          x13 = XVECEXP (x3, 0, 9);
          if (XWINT (x13, 0) != 10LL)
            return -1;
          x14 = XVECEXP (x3, 0, 10);
          if (XWINT (x14, 0) != 12LL)
            return -1;
          x15 = XVECEXP (x3, 0, 11);
          if (XWINT (x15, 0) != 14LL)
            return -1;
          x16 = XVECEXP (x3, 0, 12);
          if (XWINT (x16, 0) != 24LL)
            return -1;
          x17 = XVECEXP (x3, 0, 13);
          if (XWINT (x17, 0) != 26LL)
            return -1;
          x18 = XVECEXP (x3, 0, 14);
          if (XWINT (x18, 0) != 28LL)
            return -1;
          x19 = XVECEXP (x3, 0, 15);
          if (XWINT (x19, 0) != 30LL
              || pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
              || !
#line 1845 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1824; /* lasx_xvpickev_h */

        default:
          return -1;
        }

    case 8LL:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 24LL)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 9LL)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 25LL)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 10LL)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 26LL)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 11LL)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 27LL
          || pattern221 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 1360 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1175; /* lsx_vilvh_b */

    case 1LL:
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 23LL)
        return -1;
      x12 = XVECEXP (x3, 0, 8);
      if (XWINT (x12, 0) != 9LL)
        return -1;
      x19 = XVECEXP (x3, 0, 15);
      if (XWINT (x19, 0) != 31LL)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 17LL:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 3LL)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 19LL)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 5LL)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 21LL)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 7LL)
            return -1;
          x13 = XVECEXP (x3, 0, 9);
          if (XWINT (x13, 0) != 25LL)
            return -1;
          x14 = XVECEXP (x3, 0, 10);
          if (XWINT (x14, 0) != 11LL)
            return -1;
          x15 = XVECEXP (x3, 0, 11);
          if (XWINT (x15, 0) != 27LL)
            return -1;
          x16 = XVECEXP (x3, 0, 12);
          if (XWINT (x16, 0) != 13LL)
            return -1;
          x17 = XVECEXP (x3, 0, 13);
          if (XWINT (x17, 0) != 29LL)
            return -1;
          x18 = XVECEXP (x3, 0, 14);
          if (XWINT (x18, 0) != 15LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern205 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                  || !
#line 1423 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1181; /* lsx_vpackod_b */

            case E_V16HImode:
              if (pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                  || !
#line 1594 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1786; /* lasx_xvpackod_h */

            default:
              return -1;
            }

        case 3LL:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 5LL)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 7LL)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 17LL)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 19LL)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 21LL)
            return -1;
          x13 = XVECEXP (x3, 0, 9);
          if (XWINT (x13, 0) != 11LL)
            return -1;
          x14 = XVECEXP (x3, 0, 10);
          if (XWINT (x14, 0) != 13LL)
            return -1;
          x15 = XVECEXP (x3, 0, 11);
          if (XWINT (x15, 0) != 15LL)
            return -1;
          x16 = XVECEXP (x3, 0, 12);
          if (XWINT (x16, 0) != 25LL)
            return -1;
          x17 = XVECEXP (x3, 0, 13);
          if (XWINT (x17, 0) != 27LL)
            return -1;
          x18 = XVECEXP (x3, 0, 14);
          if (XWINT (x18, 0) != 29LL
              || pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
              || !
#line 1921 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1828; /* lasx_xvpickod_h */

        default:
          return -1;
        }

    case 4LL:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 20LL)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 5LL)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 21LL)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 6LL)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 22LL)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 7LL)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 23LL
          || pattern221 (x2, 
E_V16HImode, 
E_V32HImode) != 0
          || !
#line 1515 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1780; /* lasx_xvilvh_h */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FMA:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern176 (x3, 
E_SFmode) != 0
                      || !(
#line 1201 "../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 53; /* *fmasf4 */

                case E_DFmode:
                  if (pattern176 (x3, 
E_DFmode) != 0
                      || !(
#line 1201 "../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 54; /* *fmadf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern177 (x3, 
E_SFmode) != 0
                      || !(
#line 1214 "../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 55; /* *fmssf4 */

                case E_DFmode:
                  if (pattern177 (x3, 
E_DFmode) != 0
                      || !(
#line 1214 "../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 56; /* *fmsdf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern178 (x3, 
E_SFmode) != 0
                      || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 57; /* *fnmssf4 */

                case E_DFmode:
                  if (pattern178 (x3, 
E_DFmode) != 0
                      || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 58; /* *fnmsdf4 */

                case E_V2DFmode:
                  if (pattern178 (x3, 
E_V2DFmode) != 0
                      || !
#line 2401 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1410; /* vfnmaddv2df4_nmadd4 */

                case E_V4SFmode:
                  if (pattern178 (x3, 
E_V4SFmode) != 0
                      || !
#line 2401 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1411; /* vfnmaddv4sf4_nmadd4 */

                case E_V4DFmode:
                  if (pattern178 (x3, 
E_V4DFmode) != 0
                      || !
#line 2811 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2024; /* xvfnmaddv4df4_nmadd4 */

                case E_V8SFmode:
                  if (pattern178 (x3, 
E_V8SFmode) != 0
                      || !
#line 2811 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2025; /* xvfnmaddv8sf4_nmadd4 */

                default:
                  return -1;
                }

            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern179 (x3, 
E_SFmode) != 0
                      || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 59; /* *fnmasf4 */

                case E_DFmode:
                  if (pattern179 (x3, 
E_DFmode) != 0
                      || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 60; /* *fnmadf4 */

                case E_V2DFmode:
                  if (pattern179 (x3, 
E_V2DFmode) != 0
                      || !
#line 2388 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1408; /* vfnmsubv2df4_nmsub4 */

                case E_V4SFmode:
                  if (pattern179 (x3, 
E_V4SFmode) != 0
                      || !
#line 2388 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1409; /* vfnmsubv4sf4_nmsub4 */

                case E_V4DFmode:
                  if (pattern179 (x3, 
E_V4DFmode) != 0
                      || !
#line 2798 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2022; /* xvfnmsubv4df4_nmsub4 */

                case E_V8SFmode:
                  if (pattern179 (x3, 
E_V8SFmode) != 0
                      || !
#line 2798 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2023; /* xvfnmsubv8sf4_nmsub4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 91; /* negsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 92; /* negdi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 94; /* negsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 95; /* negdf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 787; /* negv2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 788; /* negv4sf2 */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || !register_operand (operands[1], E_V4DFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 789; /* negv4df2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !register_operand (operands[1], E_V8SFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 790; /* negv8sf2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 2034 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1324; /* vnegv2di2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 2034 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1325; /* vnegv4si2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 2034 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1326; /* vnegv8hi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2034 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1327; /* vnegv16qi2 */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !register_operand (operands[1], E_V4DImode)
              || !
#line 2494 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1951; /* negv4di2 */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode
              || !register_operand (operands[1], E_V8SImode)
              || !
#line 2494 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1952; /* negv8si2 */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !register_operand (operands[1], E_V16HImode)
              || !
#line 2494 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1953; /* negv16hi2 */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !register_operand (operands[1], E_V32QImode)
              || !
#line 2494 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1954; /* negv32qi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern112 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 140; /* fix_truncsfsi2 */

            case 1:
              if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 142; /* fix_truncdfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern112 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 141; /* fix_truncsfdi2 */

            case 1:
              if (!(
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 143; /* fix_truncdfdi2 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 599; /* fix_truncv2dfv2di2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 600; /* fix_truncv4sfv4si2 */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !register_operand (operands[1], E_V4DFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 601; /* fix_truncv4dfv4di2 */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode
              || !register_operand (operands[1], E_V8SFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 602; /* fix_truncv8sfv8si2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      switch (XINT (x4, 1))
        {
        case 53:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 579; /* lsx_vftintrp_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 584; /* lsx_vftintrp_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 589; /* lasx_xvftintrp_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 594; /* lasx_xvftintrp_w_s */

            default:
              return -1;
            }

        case 54:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 580; /* lsx_vftintrz_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 585; /* lsx_vftintrz_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 590; /* lasx_xvftintrz_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 595; /* lasx_xvftintrz_w_s */

            default:
              return -1;
            }

        case 55:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 581; /* lsx_vftint_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 586; /* lsx_vftint_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 591; /* lasx_xvftint_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 596; /* lasx_xvftint_w_s */

            default:
              return -1;
            }

        case 56:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 582; /* lsx_vftintrm_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 587; /* lsx_vftintrm_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 592; /* lasx_xvftintrm_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 597; /* lasx_xvftintrm_w_s */

            default:
              return -1;
            }

        case 57:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 583; /* lsx_vftintrne_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 588; /* lsx_vftintrne_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 593; /* lasx_xvftintrne_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 598; /* lasx_xvftintrne_w_s */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern93 (x3, 
E_V4SFmode, 
E_V2DImode, 
E_V2SFmode))
        {
        case 0:
          if (!
#line 2512 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1422; /* vec_unpack_sfix_trunc_hi_v4sf */

        case 1:
          if (!
#line 2523 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1423; /* vec_unpack_sfix_trunc_lo_v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern153 (x3, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 302 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 935; /* vec_pack_trunc_v2di */

        case E_V8HImode:
          if (pattern153 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 302 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 936; /* vec_pack_trunc_v4si */

        case E_V16QImode:
          if (pattern153 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 302 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 937; /* vec_pack_trunc_v8hi */

        case E_V8SImode:
          if (pattern153 (x3, 
E_V4DImode, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 400 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1531; /* vec_pack_trunc_v4di */

        case E_V16HImode:
          if (pattern153 (x3, 
E_V8SImode, 
E_V8HImode, 
E_V16HImode) != 0
              || !
#line 400 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1532; /* vec_pack_trunc_v8si */

        case E_V32QImode:
          if (pattern153 (x3, 
E_V16HImode, 
E_V16QImode, 
E_V32QImode) != 0
              || !
#line 400 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1533; /* vec_pack_trunc_v16hi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != FLOAT_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern153 (x3, 
E_V2DFmode, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 1804 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1283; /* vec_pack_trunc_v2df */

        case E_V8SFmode:
          if (pattern153 (x3, 
E_V4DFmode, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 2213 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1892; /* vec_pack_trunc_v4df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern12 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 1926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1312; /* vec_concatv2df */

        case E_V4DImode:
          if (pattern12 (x3, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1536; /* vec_concatv4di */

        case E_V8SImode:
          if (pattern12 (x3, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1537; /* vec_concatv8si */

        case E_V16HImode:
          if (pattern12 (x3, 
E_V8HImode, 
E_V16HImode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1538; /* vec_concatv16hi */

        case E_V32QImode:
          if (pattern12 (x3, 
E_V16QImode, 
E_V32QImode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1539; /* vec_concatv32qi */

        case E_V4DFmode:
          if (pattern12 (x3, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1540; /* vec_concatv4df */

        case E_V8SFmode:
          if (pattern12 (x3, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1541; /* vec_concatv8sf */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pattern94 (x3) != 0
          || !
#line 1949 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1313; /* vec_concatv4sf */

    case FLOAT:
      if (pattern95 (x3, 
E_V2DImode, 
E_V4SFmode, 
E_V2SFmode, 
FLOAT) != 0
          || !
#line 2421 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1413; /* vec_packs_float_v2di */

    case FIX:
      if (pattern95 (x3, 
E_V2DFmode, 
E_V4SImode, 
E_V2SImode, 
FIX) != 0
          || !
#line 2431 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1414; /* vec_pack_sfix_trunc_v2df */

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern116 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 297; /* *slt_sisi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 299; /* *slt_disi */

        default:
          return -1;
        }

    case E_DImode:
      if (pattern4 (x3, 
E_DImode) != 0
          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 301; /* *slt_didi */

    case E_FCCmode:
      switch (pattern11 (x3))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 314; /* slt_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 328; /* slt_df_using_FCCmode */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern117 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 664; /* lsx_vfcmp_slt_d */

        case 1:
          if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1120; /* lsx_vslt_d */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern118 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 674; /* lsx_vfcmp_slt_s */

        case 1:
          if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1125; /* lsx_vslt_w */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern119 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 684; /* lasx_xvfcmp_slt_d */

        case 1:
          if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1724; /* lasx_xvslt_d */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern120 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 694; /* lasx_xvfcmp_slt_s */

        case 1:
          if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1729; /* lasx_xvslt_w */

        default:
          return -1;
        }

    case E_V8HImode:
      if (pattern2 (x3, 
E_V8HImode) != 0
          || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1130; /* lsx_vslt_h */

    case E_V16QImode:
      if (pattern2 (x3, 
E_V16QImode) != 0
          || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1135; /* lsx_vslt_b */

    case E_V16HImode:
      if (pattern2 (x3, 
E_V16HImode) != 0
          || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1734; /* lasx_xvslt_h */

    case E_V32QImode:
      if (pattern2 (x3, 
E_V32QImode) != 0
          || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1739; /* lasx_xvslt_b */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern3 (x1))
    {
    case 0:
      if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 79; /* smaxsf3 */

    case 1:
      if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 80; /* smaxdf3 */

    case 2:
      if (!
#line 1176 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1151; /* smaxv2df3 */

    case 3:
      if (!
#line 1176 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1152; /* smaxv4sf3 */

    case 4:
      if (!
#line 1557 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1191; /* smaxv2di3 */

    case 5:
      if (!
#line 1557 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1192; /* smaxv4si3 */

    case 6:
      if (!
#line 1557 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1193; /* smaxv8hi3 */

    case 7:
      if (!
#line 1557 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1194; /* smaxv16qi3 */

    case 8:
      if (!
#line 1287 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1755; /* smaxv4df3 */

    case 9:
      if (!
#line 1287 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1756; /* smaxv8sf3 */

    case 10:
      if (!
#line 1737 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1795; /* smaxv4di3 */

    case 11:
      if (!
#line 1737 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1796; /* smaxv8si3 */

    case 12:
      if (!
#line 1737 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1797; /* smaxv16hi3 */

    case 13:
      if (!
#line 1737 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1798; /* smaxv32qi3 */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode))
            {
              if (peep2_current_count >= 3
                  && pattern174 (x3, 
E_SImode) == 0
                  && 
#line 1654 "../../gcc/config/loongarch/loongarch.md"
(peep2_reg_dead_p (3, operands[0])))
                {
                  *pmatch_len_ = 2;
                  res = gen_peephole2_1 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (non_volatile_mem_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x3, 0);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_SImode))
                    {
                      x6 = XEXP (x3, 1);
                      operands[3] = x6;
                      if (non_volatile_mem_operand (operands[3], E_SImode)
                          && 
#line 4421 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, true)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_4 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (!memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 4434 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_DImode:
          if (peep2_current_count < 3
              || !register_operand (operands[0], E_DImode)
              || pattern174 (x3, 
E_DImode) != 0
              || !(
#line 1654 "../../gcc/config/loongarch/loongarch.md"
(peep2_reg_dead_p (3, operands[0])) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_2 (insn, operands);

        case E_HImode:
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (register_operand (operands[2], E_HImode)
              && register_operand (operands[0], E_HImode)
              && non_volatile_mem_operand (operands[1], E_HImode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (non_volatile_mem_operand (operands[3], E_HImode)
                  && 
#line 4421 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_3 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_HImode)
              || !memory_operand (operands[0], E_HImode)
              || !register_operand (operands[1], E_HImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_HImode)
              || !
#line 4434 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_7 (insn, operands);

        case E_SFmode:
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_SFmode)
              && non_volatile_mem_operand (operands[1], E_SFmode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (non_volatile_mem_operand (operands[3], E_SFmode)
                  && (
#line 4421 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, true)) && 
#line 381 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_5 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_SFmode)
              || !memory_operand (operands[0], E_SFmode)
              || !register_operand (operands[1], E_SFmode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SFmode)
              || !(
#line 4434 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, false)) && 
#line 381 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_9 (insn, operands);

        case E_DFmode:
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (register_operand (operands[2], E_DFmode)
              && register_operand (operands[0], E_DFmode)
              && non_volatile_mem_operand (operands[1], E_DFmode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (non_volatile_mem_operand (operands[3], E_DFmode)
                  && (
#line 4421 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, true)) && 
#line 382 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_6 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_DFmode)
              || !memory_operand (operands[0], E_DFmode)
              || !register_operand (operands[1], E_DFmode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_DFmode)
              || !(
#line 4434 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, false)) && 
#line 382 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_10 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (pattern107 (x4, 
SIGN_EXTEND) != 0
          || !
#line 4466 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    case ZERO_EXTEND:
      if (pattern107 (x4, 
ZERO_EXTEND) != 0
          || !
#line 4466 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_12 (insn, operands);

    case VEC_DUPLICATE:
      if (GET_MODE (x4) != E_V2DImode
          || !register_operand (operands[0], E_V2DImode))
        return NULL;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_MERGE
          || GET_MODE (x6) != E_V2DImode)
        return NULL;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != VEC_DUPLICATE
          || GET_MODE (x8) != E_V2DImode)
        return NULL;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DImode))
        return NULL;
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!register_operand (operands[3], E_DImode))
        return NULL;
      x10 = XEXP (x6, 1);
      operands[4] = x10;
      if (!register_operand (operands[4], E_V2DImode))
        return NULL;
      x11 = XEXP (x6, 2);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_VOIDmode)
          || !
#line 3216 "../../gcc/config/loongarch/lsx.md"
(operands[0] == operands[2] &&
   operands[1] == operands[3] &&
   operands[2] == operands[4] &&
   INTVAL (operands[5]) == 2))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_13 (insn, operands);

    default:
      return NULL;
    }
}
