/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_vector_same_val_operand (operands[2], i1)
      || !const_uimm5_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern13 (x3); /* [-1, 5] */
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern29 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V2TImode, 
E_V1TImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern29 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V4DImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern29 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern29 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V16HImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2TImode:
      if (pattern29 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V4TImode, 
E_V2TImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern29 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V8DImode, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern29 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V16SImode, 
E_V8SImode) != 0)
        return -1;
      return 6;

    case E_V16HImode:
      if (pattern29 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V32HImode, 
E_V16HImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern49 (x3, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern49 (x3, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern64 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !const_uimm5_operand (operands[2], E_VOIDmode))
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern65 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern66 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern68 (x3, 
E_V4DImode, 
E_V8SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern69 (x3, 
E_V8SImode, 
E_V16HImode) != 0)
        return -1;
      return 1;

    case E_V16HImode:
      if (pattern70 (x3, 
E_V32QImode, 
E_V16HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern91 (x1, 
E_V2DFmode, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern91 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4DImode:
      if (pattern91 (x1, 
E_V4DFmode, 
E_V4DImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (pattern91 (x1, 
E_V8SFmode, 
E_V8SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (!register_operand (x4, E_SImode))
    return -1;
  return 0;
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case 8LL:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 56LL)
        return -1;
      return 0;

    case 16LL:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 48LL)
        return -1;
      return 1;

    case 24LL:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 40LL)
        return -1;
      return 2;

    case 32LL:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 32LL)
        return -1;
      return 3;

    case 40LL:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 24LL)
        return -1;
      return 4;

    case 48LL:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 16LL)
        return -1;
      return 5;

    case 56LL:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 8LL)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !register_operand (operands[1], E_SImode)
      || !plus_si_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !uns_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_vector_same_val_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern164 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern170 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !const_exp_4_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern186 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !aq12b_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern196 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !const_0_or_1_operand (operands[2], i1))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode)
          || !const_0_to_3_operand (operands[2], i1))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_immalsl_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[4] = x8;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern213 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 560; /* lsx_vfrintrz_d */

    case 1:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 565; /* lsx_vfrintrz_s */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 570; /* lasx_xvfrintrz_d */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 575; /* lasx_xvfrintrz_s */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
        return -1;
      return 438; /* stack_tiesi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_DImode)
          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 439; /* stack_tiedi */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (pattern140 (x3, 
E_V4DImode) != 0
          || !
#line 3514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2148; /* lasx_xvpickve_d */

    case E_V4DFmode:
      if (pattern140 (x3, 
E_V4DFmode) != 0
          || !
#line 3514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2149; /* lasx_xvpickve_d_f */

    case E_V8SImode:
      if (pattern142 (x3, 
E_V8SImode) != 0
          || !
#line 3514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2150; /* lasx_xvpickve_w */

    case E_V8SFmode:
      if (pattern142 (x3, 
E_V8SFmode) != 0
          || !
#line 3514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2151; /* lasx_xvpickve_w_f */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 2697 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2012; /* lasx_xvsigncov_d */

    case 1:
      if (!
#line 2697 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2013; /* lasx_xvsigncov_w */

    case 2:
      if (!
#line 2697 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2014; /* lasx_xvsigncov_h */

    case 3:
      if (!
#line 2697 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2015; /* lasx_xvsigncov_b */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1190 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1717; /* lasx_xvbitseti_d */

    case 1:
      if (!
#line 1190 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1718; /* lasx_xvbitseti_w */

    case 2:
      if (!
#line 1190 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1719; /* lasx_xvbitseti_h */

    case 3:
      if (!
#line 1190 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1720; /* lasx_xvbitseti_b */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1076 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1674; /* lasx_xvavg_s_d */

    case 1:
      if (!
#line 1076 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1675; /* lasx_xvavg_s_w */

    case 2:
      if (!
#line 1076 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1676; /* lasx_xvavg_s_h */

    case 3:
      if (!
#line 1076 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1677; /* lasx_xvavg_s_b */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 1040 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1109; /* lsx_vbitset_d */

    case 1:
      if (!
#line 1040 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1110; /* lsx_vbitset_w */

    case 2:
      if (!
#line 1040 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1111; /* lsx_vbitset_h */

    case 3:
      if (!
#line 1040 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1112; /* lsx_vbitset_b */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 754; /* lsx_vfcmp_sune_d */

    case 1:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 762; /* lsx_vfcmp_sune_s */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 770; /* lasx_xvfcmp_sune_d */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 778; /* lasx_xvfcmp_sune_s */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern87 (x1, pnum_clobbers))
    {
    case 0:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern189 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
                return -1;
              return 166; /* *seleqsi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 170; /* *seleqsi_using_di */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern189 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && ((((
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))))
                return -1;
              return 168; /* *seleqdi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 172; /* *seleqdi_using_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1288; /* lsx_bz_d */

    case 2:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1290; /* lsx_bz_w */

    case 3:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1292; /* lsx_bz_h */

    case 4:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1294; /* lsx_bz_b */

    case 5:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1296; /* lsx_bz_d_f */

    case 6:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1298; /* lsx_bz_w_f */

    case 7:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1300; /* lsx_bz_v_d */

    case 8:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1302; /* lsx_bz_v_w */

    case 9:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1304; /* lsx_bz_v_h */

    case 10:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1306; /* lsx_bz_v_b */

    case 11:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1308; /* lsx_bz_v_d_f */

    case 12:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1310; /* lsx_bz_v_w_f */

    case 13:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1899; /* lasx_xbz_d */

    case 14:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1901; /* lasx_xbz_w */

    case 15:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1903; /* lasx_xbz_h */

    case 16:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1905; /* lasx_xbz_b */

    case 17:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1907; /* lasx_xbz_d_f */

    case 18:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1909; /* lasx_xbz_w_f */

    case 19:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1911; /* lasx_xbz_v_d */

    case 20:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1913; /* lasx_xbz_v_w */

    case 21:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1915; /* lasx_xbz_v_h */

    case 22:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1917; /* lasx_xbz_v_b */

    case 23:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1919; /* lasx_xbz_v_d_f */

    case 24:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1921; /* lasx_xbz_v_w_f */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 1LL:
      if (XWINT (x5, 0) != 3LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern205 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 1404 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1179; /* lsx_vilvh_d */

        case E_V2DFmode:
          if (pattern205 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 1404 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1180; /* lsx_vilvh_d_f */

        default:
          return -1;
        }

    case 0LL:
      if (XWINT (x5, 0) != 2LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern205 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 1536 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1189; /* lsx_vilvl_d */

        case E_V2DFmode:
          if (pattern205 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 1548 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1190; /* lsx_vilvl_d_f */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_DImode)
              && 
#line 1141 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1143; /* lsx_vreplgr2vr_d */
          if (!register_operand (operands[1], E_DImode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1275; /* lsx_vreplvei_d_scalar */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_SImode)
              && 
#line 1141 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1144; /* lsx_vreplgr2vr_w */
          if (!register_operand (operands[1], E_SImode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1276; /* lsx_vreplvei_w_scalar */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_HImode)
              && 
#line 1141 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1145; /* lsx_vreplgr2vr_h */
          if (!register_operand (operands[1], E_HImode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1277; /* lsx_vreplvei_h_scalar */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_QImode)
              && 
#line 1141 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1146; /* lsx_vreplgr2vr_b */
          if (!register_operand (operands[1], E_QImode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1278; /* lsx_vreplvei_b_scalar */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1279; /* lsx_vreplvei_d_f_scalar */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1280; /* lsx_vreplvei_w_f_scalar */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !reg_or_0_operand (operands[1], E_DImode)
              || !
#line 1251 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1747; /* lasx_xvreplgr2vr_d */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode
              || !reg_or_0_operand (operands[1], E_SImode)
              || !
#line 1251 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1748; /* lasx_xvreplgr2vr_w */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !reg_or_0_operand (operands[1], E_HImode)
              || !
#line 1251 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1749; /* lasx_xvreplgr2vr_h */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !reg_or_0_operand (operands[1], E_QImode)
              || !
#line 1251 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1750; /* lasx_xvreplgr2vr_b */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 2174 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1887; /* lasx_xvreplve0_d_f_scalar */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 2174 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1888; /* lasx_xvreplve0_w_f_scalar */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern182 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1257; /* lsx_vreplve_d */

            case E_V4SImode:
              if (pattern182 (x3, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1258; /* lsx_vreplve_w */

            case E_V8HImode:
              if (pattern182 (x3, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1259; /* lsx_vreplve_h */

            case E_V16QImode:
              if (pattern182 (x3, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1260; /* lsx_vreplve_b */

            case E_V2DFmode:
              if (pattern182 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1261; /* lsx_vreplve_d_f */

            case E_V4SFmode:
              if (pattern182 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1262; /* lsx_vreplve_w_f */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern180 (x3, 
E_V2DImode, 
E_DImode) == 0
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1269; /* lsx_vreplvei_d */
              break;

            case E_V4SImode:
              if (pattern181 (x3, 
E_V4SImode, 
E_SImode) == 0
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1270; /* lsx_vreplvei_w */
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x3) == E_V8HImode
                  && GET_MODE (x4) == E_HImode
                  && register_operand (operands[1], E_V8HImode)
                  && const_uimm3_operand (operands[2], E_VOIDmode)
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1271; /* lsx_vreplvei_h */
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x3) == E_V16QImode
                  && GET_MODE (x4) == E_QImode
                  && register_operand (operands[1], E_V16QImode)
                  && const_uimm4_operand (operands[2], E_VOIDmode)
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1272; /* lsx_vreplvei_b */
              break;

            case E_V2DFmode:
              if (pattern180 (x3, 
E_V2DFmode, 
E_DFmode) == 0
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1273; /* lsx_vreplvei_d_f */
              break;

            case E_V4SFmode:
              if (pattern181 (x3, 
E_V4SFmode, 
E_SFmode) == 0
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1274; /* lsx_vreplvei_w_f */
              break;

            default:
              break;
            }
          if (XWINT (x7, 0) != 0LL)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DImode:
              if (pattern182 (x3, 
E_V4DImode, 
E_DImode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1871; /* lasx_xvreplve0_d */

            case E_V8SImode:
              if (pattern182 (x3, 
E_V8SImode, 
E_SImode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1872; /* lasx_xvreplve0_w */

            case E_V16HImode:
              if (pattern182 (x3, 
E_V16HImode, 
E_HImode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1873; /* lasx_xvreplve0_h */

            case E_V32QImode:
              if (pattern182 (x3, 
E_V32QImode, 
E_QImode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1874; /* lasx_xvreplve0_b */

            case E_V4DFmode:
              if (pattern182 (x3, 
E_V4DFmode, 
E_DFmode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1875; /* lasx_xvreplve0_d_f */

            case E_V8SFmode:
              if (pattern182 (x3, 
E_V8SFmode, 
E_SFmode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1876; /* lasx_xvreplve0_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case PLUS:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern183 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1430; /* lsx_vldrepl_d_insn */

            case E_V4SImode:
              if (pattern184 (x3, 
E_SImode, 
E_V4SImode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1431; /* lsx_vldrepl_w_insn */

            case E_V8HImode:
              if (pattern185 (x3, 
E_V8HImode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1432; /* lsx_vldrepl_h_insn */

            case E_V16QImode:
              if (pattern186 (x3, 
E_V16QImode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1433; /* lsx_vldrepl_b_insn */

            case E_V2DFmode:
              if (pattern183 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1434; /* lsx_vldrepl_d_f_insn */

            case E_V4SFmode:
              if (pattern184 (x3, 
E_SFmode, 
E_V4SFmode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1435; /* lsx_vldrepl_w_f_insn */

            case E_V4DImode:
              if (pattern183 (x3, 
E_DImode, 
E_V4DImode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2044; /* lasx_xvldrepl_d_insn */

            case E_V8SImode:
              if (pattern184 (x3, 
E_SImode, 
E_V8SImode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2045; /* lasx_xvldrepl_w_insn */

            case E_V16HImode:
              if (pattern185 (x3, 
E_V16HImode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2046; /* lasx_xvldrepl_h_insn */

            case E_V32QImode:
              if (pattern186 (x3, 
E_V32QImode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2047; /* lasx_xvldrepl_b_insn */

            case E_V4DFmode:
              if (pattern183 (x3, 
E_DFmode, 
E_V4DFmode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2048; /* lasx_xvldrepl_d_f_insn */

            case E_V8SFmode:
              if (pattern184 (x3, 
E_SFmode, 
E_V8SFmode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2049; /* lasx_xvldrepl_w_f_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x3) != E_V2DImode
                  || GET_MODE (x4) != E_DImode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1436; /* lsx_vldrepl_d_insn_0 */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || GET_MODE (x4) != E_SImode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1437; /* lsx_vldrepl_w_insn_0 */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || GET_MODE (x4) != E_HImode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1438; /* lsx_vldrepl_h_insn_0 */

            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x3) != E_V16QImode
                  || GET_MODE (x4) != E_QImode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1439; /* lsx_vldrepl_b_insn_0 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x4) != E_DFmode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1440; /* lsx_vldrepl_d_f_insn_0 */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_SFmode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1441; /* lsx_vldrepl_w_f_insn_0 */

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x3) != E_V4DImode
                  || GET_MODE (x4) != E_DImode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2050; /* lasx_xvldrepl_d_insn_0 */

            case E_V8SImode:
              if (!register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x3) != E_V8SImode
                  || GET_MODE (x4) != E_SImode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2051; /* lasx_xvldrepl_w_insn_0 */

            case E_V16HImode:
              if (!register_operand (operands[0], E_V16HImode)
                  || GET_MODE (x3) != E_V16HImode
                  || GET_MODE (x4) != E_HImode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2052; /* lasx_xvldrepl_h_insn_0 */

            case E_V32QImode:
              if (!register_operand (operands[0], E_V32QImode)
                  || GET_MODE (x3) != E_V32QImode
                  || GET_MODE (x4) != E_QImode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2053; /* lasx_xvldrepl_b_insn_0 */

            case E_V4DFmode:
              if (!register_operand (operands[0], E_V4DFmode)
                  || GET_MODE (x3) != E_V4DFmode
                  || GET_MODE (x4) != E_DFmode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2054; /* lasx_xvldrepl_d_f_insn_0 */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x3) != E_V8SFmode
                  || GET_MODE (x4) != E_SFmode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2055; /* lasx_xvldrepl_w_f_insn_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 12; /* mulsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 13; /* muldf3 */

        case E_SImode:
          if (pattern0 (x3, 
E_SImode) != 0)
            return -1;
          return 14; /* *mulsi3 */

        case E_DImode:
          if (pattern0 (x3, 
E_DImode) != 0
              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 15; /* *muldi3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !
#line 596 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 976; /* mulv2di3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 596 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 977; /* mulv4si3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 596 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 978; /* mulv8hi3 */

        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 596 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 979; /* mulv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1042; /* mulv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1043; /* mulv4sf3 */

        case E_V4DImode:
          if (pattern0 (x3, 
E_V4DImode) != 0
              || !
#line 720 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1578; /* mulv4di3 */

        case E_V8SImode:
          if (pattern0 (x3, 
E_V8SImode) != 0
              || !
#line 720 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1579; /* mulv8si3 */

        case E_V16HImode:
          if (pattern0 (x3, 
E_V16HImode) != 0
              || !
#line 720 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1580; /* mulv16hi3 */

        case E_V32QImode:
          if (pattern0 (x3, 
E_V32QImode) != 0
              || !
#line 720 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1581; /* mulv32qi3 */

        case E_V4DFmode:
          if (pattern0 (x3, 
E_V4DFmode) != 0
              || !
#line 954 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1644; /* mulv4df3 */

        case E_V8SFmode:
          if (pattern0 (x3, 
E_V8SFmode) != 0
              || !
#line 954 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1645; /* mulv8sf3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 949 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 19; /* mulsidi3_64bit */

        case VEC_SELECT:
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != VEC_SELECT)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          switch (pattern158 (x3))
            {
            case 0:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 793; /* simd_mulw_evod_v2di_s */

            case 1:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 799; /* simd_mulw_evod_v4si_s */

            case 2:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 805; /* simd_mulw_evod_v8hi_s */

            case 3:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 811; /* simd_mulw_evod_v16qi_s */

            case 4:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 817; /* simd_mulw_evod_v4di_s */

            case 5:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 823; /* simd_mulw_evod_v8si_s */

            case 6:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 829; /* simd_mulw_evod_v16hi_s */

            case 7:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 835; /* simd_mulw_evod_v32qi_s */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 949 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 20; /* umulsidi3_64bit */

        case VEC_SELECT:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x5, 0);
              if (GET_CODE (x7) != VEC_SELECT)
                return -1;
              switch (pattern158 (x3))
                {
                case 0:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 796; /* simd_mulw_evod_v2di_u */

                case 1:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 802; /* simd_mulw_evod_v4si_u */

                case 2:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 808; /* simd_mulw_evod_v8hi_u */

                case 3:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 814; /* simd_mulw_evod_v16qi_u */

                case 4:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 820; /* simd_mulw_evod_v4di_u */

                case 5:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 826; /* simd_mulw_evod_v8si_u */

                case 6:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 832; /* simd_mulw_evod_v16hi_u */

                case 7:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 838; /* simd_mulw_evod_v32qi_u */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern30 (x3))
                {
                case 0:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 841; /* simd_mulw_evod_v2di_hetero */

                case 1:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 844; /* simd_mulw_evod_v4si_hetero */

                case 2:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 847; /* simd_mulw_evod_v8hi_hetero */

                case 3:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 850; /* simd_mulw_evod_v16qi_hetero */

                case 4:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 853; /* simd_mulw_evod_v4di_hetero */

                case 5:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 856; /* simd_mulw_evod_v8si_hetero */

                case 6:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 859; /* simd_mulw_evod_v16hi_hetero */

                case 7:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 862; /* simd_mulw_evod_v32qi_hetero */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern5 (x3))
        {
        case 0:
          return 251; /* *rotrsi3 */

        case 1:
          if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 252; /* *rotrdi3 */

        case 2:
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 619; /* vrotrv2di3 */
          if (!const_uimm6_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 630; /* rotrv2di3 */

        case 3:
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 620; /* vrotrv4si3 */
          if (!const_uimm5_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 634; /* rotrv4si3 */

        case 4:
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 621; /* vrotrv8hi3 */
          if (!const_uimm4_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 638; /* rotrv8hi3 */

        case 5:
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 622; /* vrotrv16qi3 */
          if (!const_uimm3_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 642; /* rotrv16qi3 */

        case 6:
          if (register_operand (operands[2], E_V4DImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 623; /* vrotrv4di3 */
          if (!const_uimm6_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 646; /* rotrv4di3 */

        case 7:
          if (register_operand (operands[2], E_V8SImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 624; /* vrotrv8si3 */
          if (!const_uimm5_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 650; /* rotrv8si3 */

        case 8:
          if (register_operand (operands[2], E_V16HImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 625; /* vrotrv16hi3 */
          if (!const_uimm4_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 654; /* rotrv16hi3 */

        case 9:
          if (register_operand (operands[2], E_V32QImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 626; /* vrotrv32qi3 */
          if (!const_uimm3_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 658; /* rotrv32qi3 */

        default:
          return -1;
        }

    case BSWAP:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XWINT (x5, 0))
        {
        case 16LL:
          if (pattern111 (x3, 
E_SImode) != 0)
            return -1;
          return 269; /* revb_2h */

        case 32LL:
          if (pattern111 (x3, 
E_DImode) != 0
              || !
#line 3243 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 272; /* revb_2w */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern83 (x3))
        {
        case 0:
          return 75; /* clzsi2 */

        case 1:
          if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 76; /* clzdi2 */

        case 2:
          if (!
#line 1608 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1211; /* clzv2di2 */

        case 3:
          if (!
#line 1608 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1212; /* clzv4si2 */

        case 4:
          if (!
#line 1608 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1213; /* clzv8hi2 */

        case 5:
          if (!
#line 1608 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1214; /* clzv16qi2 */

        case 6:
          if (!
#line 1788 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1815; /* clzv4di2 */

        case 7:
          if (!
#line 1788 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1816; /* clzv8si2 */

        case 8:
          if (!
#line 1788 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1817; /* clzv16hi2 */

        case 9:
          if (!
#line 1788 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1818; /* clzv32qi2 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern111 (x3, 
E_V2DImode) != 0
              || !
#line 1600 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1207; /* lsx_vclo_d */

        case E_V4SImode:
          if (pattern111 (x3, 
E_V4SImode) != 0
              || !
#line 1600 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1208; /* lsx_vclo_w */

        case E_V8HImode:
          if (pattern111 (x3, 
E_V8HImode) != 0
              || !
#line 1600 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1209; /* lsx_vclo_h */

        case E_V16QImode:
          if (pattern111 (x3, 
E_V16QImode) != 0
              || !
#line 1600 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1210; /* lsx_vclo_b */

        case E_V4DImode:
          if (pattern111 (x3, 
E_V4DImode) != 0
              || !
#line 1780 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1811; /* lasx_xvclo_d */

        case E_V8SImode:
          if (pattern111 (x3, 
E_V8SImode) != 0
              || !
#line 1780 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1812; /* lasx_xvclo_w */

        case E_V16HImode:
          if (pattern111 (x3, 
E_V16HImode) != 0
              || !
#line 1780 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1813; /* lasx_xvclo_h */

        case E_V32QImode:
          if (pattern111 (x3, 
E_V32QImode) != 0
              || !
#line 1780 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1814; /* lasx_xvclo_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 341; /* tablejumpsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 342; /* tablejumpdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x8;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern200 (
E_HImode) != 0
                  || !
#line 4401 "../../gcc/config/loongarch/loongarch.md"
(reload_completed))
                return -1;
              return 440; /* *join2_load_storehi */

            case E_SImode:
              if (pattern200 (
E_SImode) != 0
                  || !
#line 4401 "../../gcc/config/loongarch/loongarch.md"
(reload_completed))
                return -1;
              return 441; /* *join2_load_storesi */

            case E_SFmode:
              if (pattern200 (
E_SFmode) != 0
                  || !(
#line 4401 "../../gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 381 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 442; /* *join2_load_storesf */

            case E_DFmode:
              if (pattern200 (
E_DFmode) != 0
                  || !(
#line 4401 "../../gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 382 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 443; /* *join2_load_storedf */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          x5 = XEXP (x4, 0);
          if (!rtx_equal_p (x5, operands[1]))
            return -1;
          switch (XVECLEN (x8, 0))
            {
            case 2:
              if (XINT (x8, 1) != 48)
                return -1;
              x9 = XVECEXP (x8, 0, 1);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x10 = XVECEXP (x8, 0, 0);
              switch (GET_CODE (x10))
                {
                case PLUS:
                  x11 = XEXP (x10, 1);
                  operands[2] = x11;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern210 (x8, 
E_SImode) != 0)
                        return -1;
                      return 509; /* atomic_fetch_addsi */

                    case E_DImode:
                      if (pattern210 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 513; /* atomic_fetch_adddi */

                    case E_QImode:
                      if (pattern210 (x8, 
E_QImode) != 0
                          || !
#line 690 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                        return -1;
                      return 543; /* atomic_fetch_addqi_short */

                    case E_HImode:
                      if (pattern210 (x8, 
E_HImode) != 0
                          || !
#line 690 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                        return -1;
                      return 544; /* atomic_fetch_addhi_short */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern211 (x8))
                    {
                    case 0:
                      return 510; /* atomic_fetch_orsi */

                    case 1:
                      if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 514; /* atomic_fetch_ordi */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern211 (x8))
                    {
                    case 0:
                      return 511; /* atomic_fetch_xorsi */

                    case 1:
                      if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 515; /* atomic_fetch_xordi */

                    default:
                      return -1;
                    }

                case AND:
                  switch (pattern211 (x8))
                    {
                    case 0:
                      return 512; /* atomic_fetch_andsi */

                    case 1:
                      if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 516; /* atomic_fetch_anddi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 3:
              if (XINT (x8, 1) != 41)
                return -1;
              x10 = XVECEXP (x8, 0, 0);
              operands[2] = x10;
              x9 = XVECEXP (x8, 0, 1);
              operands[3] = x9;
              x13 = XVECEXP (x8, 0, 2);
              operands[4] = x13;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern214 (x8, 
E_SImode) != 0)
                    return -1;
                  if (pnum_clobbers != NULL)
                    {
                      *pnum_clobbers = 1;
                      return 521; /* atomic_cas_value_strongsi */
                    }
                  if (!
#line 293 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS))
                    return -1;
                  return 525; /* atomic_cas_value_strongsi_amcas */

                case E_DImode:
                  if (pattern214 (x8, 
E_DImode) != 0)
                    return -1;
                  if (pnum_clobbers != NULL
                      && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 522; /* atomic_cas_value_strongdi */
                    }
                  if (!(
#line 293 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS) && 
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                    return -1;
                  return 526; /* atomic_cas_value_strongdi_amcas */

                case E_QImode:
                  if (pattern214 (x8, 
E_QImode) != 0
                      || !
#line 293 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS))
                    return -1;
                  return 523; /* atomic_cas_value_strongqi_amcas */

                case E_HImode:
                  if (pattern214 (x8, 
E_HImode) != 0
                      || !
#line 293 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS))
                    return -1;
                  return 524; /* atomic_cas_value_stronghi_amcas */

                default:
                  return -1;
                }

            case 5:
              if (pnum_clobbers == NULL)
                return -1;
              x10 = XVECEXP (x8, 0, 0);
              operands[2] = x10;
              x9 = XVECEXP (x8, 0, 1);
              operands[3] = x9;
              x13 = XVECEXP (x8, 0, 2);
              operands[4] = x13;
              x14 = XVECEXP (x8, 0, 3);
              operands[5] = x14;
              x15 = XVECEXP (x8, 0, 4);
              operands[6] = x15;
              if (!const_int_operand (operands[6], E_SImode))
                return -1;
              switch (XINT (x8, 1))
                {
                case 41:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 1;
                      return 527; /* atomic_cas_value_cmp_and_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 528; /* atomic_cas_value_cmp_and_7_di */

                    default:
                      return -1;
                    }

                case 42:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 529; /* atomic_cas_value_add_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 530; /* atomic_cas_value_add_7_di */

                    default:
                      return -1;
                    }

                case 43:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 531; /* atomic_cas_value_sub_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 532; /* atomic_cas_value_sub_7_di */

                    default:
                      return -1;
                    }

                case 44:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 533; /* atomic_cas_value_and_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 534; /* atomic_cas_value_and_7_di */

                    default:
                      return -1;
                    }

                case 45:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 535; /* atomic_cas_value_xor_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 536; /* atomic_cas_value_xor_7_di */

                    default:
                      return -1;
                    }

                case 46:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 537; /* atomic_cas_value_or_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 538; /* atomic_cas_value_or_7_di */

                    default:
                      return -1;
                    }

                case 47:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 539; /* atomic_cas_value_nand_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 540; /* atomic_cas_value_nand_7_di */

                    default:
                      return -1;
                    }

                case 49:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 1;
                      return 541; /* atomic_cas_value_exchange_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 542; /* atomic_cas_value_exchange_7_di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
