/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_vector_same_val_operand (operands[2], i1)
      || !const_uimm4_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern0 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 5;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 6;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern41 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT
      || !register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || GET_MODE (x2) != i2)
    return -1;
  return pattern40 (x3, 
i1); /* [-1, 1] */
}

int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern61 (x3, 
E_V2DFmode, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern61 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4DImode:
      if (pattern61 (x3, 
E_V4DFmode, 
E_V4DImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (pattern61 (x3, 
E_V8SFmode, 
E_V8SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2DImode))
    return -1;
  return 0;
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 3;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 5;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 6;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 7;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 8;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern112 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !sle_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !sle_operand (operands[2], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !sle_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!memory_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!memory_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern58 (x1, 
E_V4DImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern58 (x1, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V16HImode:
      if (pattern58 (x1, 
E_V16HImode) != 0)
        return -1;
      return 2;

    case E_V32QImode:
      if (pattern58 (x1, 
E_V32QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern163 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_0_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !const_exp_4_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern192 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_exp_4_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern210 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern210 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[4] = x10;
      switch (pattern188 (x2))
        {
        case 0:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 895; /* simd_maddw_evod_v2di_s */

        case 1:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 897; /* simd_maddw_evod_v4si_s */

        case 2:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 899; /* simd_maddw_evod_v8hi_s */

        case 3:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 901; /* simd_maddw_evod_v16qi_s */

        case 4:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 903; /* simd_maddw_evod_v4di_s */

        case 5:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 905; /* simd_maddw_evod_v8si_s */

        case 6:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 907; /* simd_maddw_evod_v16hi_s */

        case 7:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 909; /* simd_maddw_evod_v32qi_s */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[4] = x10;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != VEC_SELECT)
            return -1;
          switch (pattern188 (x2))
            {
            case 0:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 896; /* simd_maddw_evod_v2di_u */

            case 1:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 898; /* simd_maddw_evod_v4si_u */

            case 2:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 900; /* simd_maddw_evod_v8hi_u */

            case 3:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 902; /* simd_maddw_evod_v16qi_u */

            case 4:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 904; /* simd_maddw_evod_v4di_u */

            case 5:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 906; /* simd_maddw_evod_v8si_u */

            case 6:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 908; /* simd_maddw_evod_v16hi_u */

            case 7:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 910; /* simd_maddw_evod_v32qi_u */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != VEC_SELECT)
            return -1;
          x11 = XEXP (x8, 0);
          operands[3] = x11;
          x12 = XEXP (x8, 1);
          if (!rtx_equal_p (x12, operands[4]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern206 (x2, 
E_V1TImode, 
E_V2DImode, 
E_V1DImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 911; /* simd_maddw_evod_v2di_hetero */

            case E_V2DImode:
              if (pattern206 (x2, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 912; /* simd_maddw_evod_v4si_hetero */

            case E_V4SImode:
              if (pattern206 (x2, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 913; /* simd_maddw_evod_v8hi_hetero */

            case E_V8HImode:
              if (pattern206 (x2, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 914; /* simd_maddw_evod_v16qi_hetero */

            case E_V2TImode:
              if (pattern206 (x2, 
E_V2TImode, 
E_V4DImode, 
E_V2DImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 915; /* simd_maddw_evod_v4di_hetero */

            case E_V4DImode:
              if (pattern206 (x2, 
E_V4DImode, 
E_V8SImode, 
E_V4SImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 916; /* simd_maddw_evod_v8si_hetero */

            case E_V8SImode:
              if (pattern206 (x2, 
E_V8SImode, 
E_V16HImode, 
E_V8HImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 917; /* simd_maddw_evod_v16hi_hetero */

            case E_V16HImode:
              if (pattern206 (x2, 
E_V16HImode, 
E_V32QImode, 
E_V16QImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 918; /* simd_maddw_evod_v32qi_hetero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x5;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern156 (x2, 
E_V2DImode) != 0
              || !
#line 606 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 980; /* lsx_vmadd_d */

        case E_V4SImode:
          if (pattern156 (x2, 
E_V4SImode) != 0
              || !
#line 606 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 981; /* lsx_vmadd_w */

        case E_V8HImode:
          if (pattern156 (x2, 
E_V8HImode) != 0
              || !
#line 606 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 982; /* lsx_vmadd_h */

        case E_V16QImode:
          if (pattern156 (x2, 
E_V16QImode) != 0
              || !
#line 606 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 983; /* lsx_vmadd_b */

        case E_V4DImode:
          if (pattern156 (x2, 
E_V4DImode) != 0
              || !
#line 730 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1582; /* lasx_xvmadd_d */

        case E_V8SImode:
          if (pattern156 (x2, 
E_V8SImode) != 0
              || !
#line 730 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1583; /* lasx_xvmadd_w */

        case E_V16HImode:
          if (pattern156 (x2, 
E_V16HImode) != 0
              || !
#line 730 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1584; /* lasx_xvmadd_h */

        case E_V32QImode:
          if (pattern156 (x2, 
E_V32QImode) != 0
              || !
#line 730 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1585; /* lasx_xvmadd_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode)
          || !
#line 2160 "../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[0], INTVAL (operands[1]),
			    INTVAL (operands[2]))))
        return -1;
      return 150; /* *insvsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode)
          || !(
#line 2160 "../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[0], INTVAL (operands[1]),
			    INTVAL (operands[2]))) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
        return -1;
      return 151; /* *insvdi */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_V32QImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_V32QImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V32QImode))
    return -1;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_uimm4_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x5, 0, 16);
  operands[3] = x7;
  if (!const_16_to_31_operand (operands[3], E_VOIDmode)
      || pattern208 (x5) != 0)
    return -1;
  x8 = XVECEXP (x5, 0, 8);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x5, 0, 9);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XVECEXP (x5, 0, 10);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x5, 0, 11);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XVECEXP (x5, 0, 12);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x5, 0, 13);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XVECEXP (x5, 0, 14);
  if (!rtx_equal_p (x14, operands[2]))
    return -1;
  x15 = XVECEXP (x5, 0, 15);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XVECEXP (x5, 0, 17);
  if (!rtx_equal_p (x16, operands[3]))
    return -1;
  x17 = XVECEXP (x5, 0, 18);
  if (!rtx_equal_p (x17, operands[3]))
    return -1;
  x18 = XVECEXP (x5, 0, 19);
  if (!rtx_equal_p (x18, operands[3]))
    return -1;
  x19 = XVECEXP (x5, 0, 20);
  if (!rtx_equal_p (x19, operands[3]))
    return -1;
  x20 = XVECEXP (x5, 0, 21);
  if (!rtx_equal_p (x20, operands[3]))
    return -1;
  x21 = XVECEXP (x5, 0, 22);
  if (!rtx_equal_p (x21, operands[3]))
    return -1;
  x22 = XVECEXP (x5, 0, 23);
  if (!rtx_equal_p (x22, operands[3]))
    return -1;
  x23 = XVECEXP (x5, 0, 24);
  if (!rtx_equal_p (x23, operands[3]))
    return -1;
  x24 = XVECEXP (x5, 0, 25);
  if (!rtx_equal_p (x24, operands[3]))
    return -1;
  x25 = XVECEXP (x5, 0, 26);
  if (!rtx_equal_p (x25, operands[3]))
    return -1;
  x26 = XVECEXP (x5, 0, 27);
  if (!rtx_equal_p (x26, operands[3]))
    return -1;
  x27 = XVECEXP (x5, 0, 28);
  if (!rtx_equal_p (x27, operands[3]))
    return -1;
  x28 = XVECEXP (x5, 0, 29);
  if (!rtx_equal_p (x28, operands[3]))
    return -1;
  x29 = XVECEXP (x5, 0, 30);
  if (!rtx_equal_p (x29, operands[3]))
    return -1;
  x30 = XVECEXP (x5, 0, 31);
  if (!rtx_equal_p (x30, operands[3])
      || !
#line 2112 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ((INTVAL (operands[3]) - INTVAL (operands[2])) == 16)))
    return -1;
  return 1877; /* lasx_xvrepl128vei_b_internal */
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_83 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  operands[4] = x5;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[5] = x6;
  if (!const_8_to_11_operand (operands[5], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[6] = x7;
  if (!const_8_to_11_operand (operands[6], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[7] = x8;
  if (!const_4_to_7_operand (operands[7], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 5);
  operands[8] = x9;
  if (!const_4_to_7_operand (operands[8], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 6);
  operands[9] = x10;
  if (!const_12_to_15_operand (operands[9], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 7);
  operands[10] = x11;
  if (!const_12_to_15_operand (operands[10], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
          || !
#line 3404 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
  && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
  && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
  && INTVAL (operands[5]) + 4 == INTVAL (operands[9])
  && INTVAL (operands[6]) + 4 == INTVAL (operands[10])))
        return -1;
      return 2130; /* lasx_xvpermi_w_1 */

    case E_V8SFmode:
      if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
          || !
#line 3404 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
  && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
  && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
  && INTVAL (operands[5]) + 4 == INTVAL (operands[9])
  && INTVAL (operands[6]) + 4 == INTVAL (operands[10])))
        return -1;
      return 2131; /* lasx_xvpermi_w_f_1 */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 16);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 17);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 18);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 19);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x3, 0, 20);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x3, 0, 21);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x3, 0, 22);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x3, 0, 23);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x3, 0, 24);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x3, 0, 25);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x3, 0, 26);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x3, 0, 27);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x3, 0, 28);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x3, 0, 29);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x3, 0, 30);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x3, 0, 31);
  if (GET_CODE (x19) != CONST_INT
      || pattern205 (x2, 
E_V32QImode, 
E_V64QImode) != 0)
    return -1;
  x20 = XVECEXP (x3, 0, 0);
  switch (XWINT (x20, 0))
    {
    case 0LL:
      if (XWINT (x4, 0) != 16LL)
        return -1;
      x21 = XVECEXP (x3, 0, 1);
      switch (XWINT (x21, 0))
        {
        case 32LL:
          if (XWINT (x5, 0) != 48LL)
            return -1;
          x22 = XVECEXP (x3, 0, 2);
          switch (XWINT (x22, 0))
            {
            case 2LL:
              x23 = XVECEXP (x3, 0, 3);
              if (XWINT (x23, 0) != 34LL)
                return -1;
              x24 = XVECEXP (x3, 0, 4);
              if (XWINT (x24, 0) != 4LL)
                return -1;
              x25 = XVECEXP (x3, 0, 5);
              if (XWINT (x25, 0) != 36LL)
                return -1;
              x26 = XVECEXP (x3, 0, 6);
              if (XWINT (x26, 0) != 6LL)
                return -1;
              x27 = XVECEXP (x3, 0, 7);
              if (XWINT (x27, 0) != 38LL)
                return -1;
              x28 = XVECEXP (x3, 0, 8);
              if (XWINT (x28, 0) != 8LL)
                return -1;
              x29 = XVECEXP (x3, 0, 9);
              if (XWINT (x29, 0) != 40LL)
                return -1;
              x30 = XVECEXP (x3, 0, 10);
              if (XWINT (x30, 0) != 10LL)
                return -1;
              x31 = XVECEXP (x3, 0, 11);
              if (XWINT (x31, 0) != 42LL)
                return -1;
              x32 = XVECEXP (x3, 0, 12);
              if (XWINT (x32, 0) != 12LL)
                return -1;
              x33 = XVECEXP (x3, 0, 13);
              if (XWINT (x33, 0) != 44LL)
                return -1;
              x34 = XVECEXP (x3, 0, 14);
              if (XWINT (x34, 0) != 14LL)
                return -1;
              x35 = XVECEXP (x3, 0, 15);
              if (XWINT (x35, 0) != 46LL
                  || XWINT (x6, 0) != 18LL
                  || XWINT (x7, 0) != 50LL
                  || XWINT (x8, 0) != 20LL
                  || XWINT (x9, 0) != 52LL
                  || XWINT (x10, 0) != 22LL
                  || XWINT (x11, 0) != 54LL
                  || XWINT (x12, 0) != 24LL
                  || XWINT (x13, 0) != 56LL
                  || XWINT (x14, 0) != 26LL
                  || XWINT (x15, 0) != 58LL
                  || XWINT (x16, 0) != 28LL
                  || XWINT (x17, 0) != 60LL
                  || XWINT (x18, 0) != 30LL
                  || XWINT (x19, 0) != 62LL
                  || !
#line 1419 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1775; /* lasx_xvpackev_b */

            case 1LL:
              x23 = XVECEXP (x3, 0, 3);
              if (XWINT (x23, 0) != 33LL)
                return -1;
              x24 = XVECEXP (x3, 0, 4);
              if (XWINT (x24, 0) != 2LL)
                return -1;
              x25 = XVECEXP (x3, 0, 5);
              if (XWINT (x25, 0) != 34LL)
                return -1;
              x26 = XVECEXP (x3, 0, 6);
              if (XWINT (x26, 0) != 3LL)
                return -1;
              x27 = XVECEXP (x3, 0, 7);
              if (XWINT (x27, 0) != 35LL)
                return -1;
              x28 = XVECEXP (x3, 0, 8);
              if (XWINT (x28, 0) != 4LL)
                return -1;
              x29 = XVECEXP (x3, 0, 9);
              if (XWINT (x29, 0) != 36LL)
                return -1;
              x30 = XVECEXP (x3, 0, 10);
              if (XWINT (x30, 0) != 5LL)
                return -1;
              x31 = XVECEXP (x3, 0, 11);
              if (XWINT (x31, 0) != 37LL)
                return -1;
              x32 = XVECEXP (x3, 0, 12);
              if (XWINT (x32, 0) != 6LL)
                return -1;
              x33 = XVECEXP (x3, 0, 13);
              if (XWINT (x33, 0) != 38LL)
                return -1;
              x34 = XVECEXP (x3, 0, 14);
              if (XWINT (x34, 0) != 7LL)
                return -1;
              x35 = XVECEXP (x3, 0, 15);
              if (XWINT (x35, 0) != 39LL
                  || XWINT (x6, 0) != 17LL
                  || XWINT (x7, 0) != 49LL
                  || XWINT (x8, 0) != 18LL
                  || XWINT (x9, 0) != 50LL
                  || XWINT (x10, 0) != 19LL
                  || XWINT (x11, 0) != 51LL
                  || XWINT (x12, 0) != 20LL
                  || XWINT (x13, 0) != 52LL
                  || XWINT (x14, 0) != 21LL
                  || XWINT (x15, 0) != 53LL
                  || XWINT (x16, 0) != 22LL
                  || XWINT (x17, 0) != 54LL
                  || XWINT (x18, 0) != 23LL
                  || XWINT (x19, 0) != 55LL
                  || !
#line 1653 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1789; /* lasx_xvilvl_b */

            default:
              return -1;
            }

        case 2LL:
          x22 = XVECEXP (x3, 0, 2);
          if (XWINT (x22, 0) != 4LL)
            return -1;
          x23 = XVECEXP (x3, 0, 3);
          if (XWINT (x23, 0) != 6LL)
            return -1;
          x24 = XVECEXP (x3, 0, 4);
          if (XWINT (x24, 0) != 8LL)
            return -1;
          x25 = XVECEXP (x3, 0, 5);
          if (XWINT (x25, 0) != 10LL)
            return -1;
          x26 = XVECEXP (x3, 0, 6);
          if (XWINT (x26, 0) != 12LL)
            return -1;
          x27 = XVECEXP (x3, 0, 7);
          if (XWINT (x27, 0) != 14LL)
            return -1;
          x28 = XVECEXP (x3, 0, 8);
          if (XWINT (x28, 0) != 32LL)
            return -1;
          x29 = XVECEXP (x3, 0, 9);
          if (XWINT (x29, 0) != 34LL)
            return -1;
          x30 = XVECEXP (x3, 0, 10);
          if (XWINT (x30, 0) != 36LL)
            return -1;
          x31 = XVECEXP (x3, 0, 11);
          if (XWINT (x31, 0) != 38LL)
            return -1;
          x32 = XVECEXP (x3, 0, 12);
          if (XWINT (x32, 0) != 40LL)
            return -1;
          x33 = XVECEXP (x3, 0, 13);
          if (XWINT (x33, 0) != 42LL)
            return -1;
          x34 = XVECEXP (x3, 0, 14);
          if (XWINT (x34, 0) != 44LL)
            return -1;
          x35 = XVECEXP (x3, 0, 15);
          if (XWINT (x35, 0) != 46LL
              || XWINT (x5, 0) != 18LL
              || XWINT (x6, 0) != 20LL
              || XWINT (x7, 0) != 22LL
              || XWINT (x8, 0) != 24LL
              || XWINT (x9, 0) != 26LL
              || XWINT (x10, 0) != 28LL
              || XWINT (x11, 0) != 30LL
              || XWINT (x12, 0) != 48LL
              || XWINT (x13, 0) != 50LL
              || XWINT (x14, 0) != 52LL
              || XWINT (x15, 0) != 54LL
              || XWINT (x16, 0) != 56LL
              || XWINT (x17, 0) != 58LL
              || XWINT (x18, 0) != 60LL
              || XWINT (x19, 0) != 62LL
              || !
#line 1826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1823; /* lasx_xvpickev_b */

        default:
          return -1;
        }

    case 8LL:
      x21 = XVECEXP (x3, 0, 1);
      if (XWINT (x21, 0) != 40LL)
        return -1;
      x22 = XVECEXP (x3, 0, 2);
      if (XWINT (x22, 0) != 9LL)
        return -1;
      x23 = XVECEXP (x3, 0, 3);
      if (XWINT (x23, 0) != 41LL)
        return -1;
      x24 = XVECEXP (x3, 0, 4);
      if (XWINT (x24, 0) != 10LL)
        return -1;
      x25 = XVECEXP (x3, 0, 5);
      if (XWINT (x25, 0) != 42LL)
        return -1;
      x26 = XVECEXP (x3, 0, 6);
      if (XWINT (x26, 0) != 11LL)
        return -1;
      x27 = XVECEXP (x3, 0, 7);
      if (XWINT (x27, 0) != 43LL)
        return -1;
      x28 = XVECEXP (x3, 0, 8);
      if (XWINT (x28, 0) != 12LL)
        return -1;
      x29 = XVECEXP (x3, 0, 9);
      if (XWINT (x29, 0) != 44LL)
        return -1;
      x30 = XVECEXP (x3, 0, 10);
      if (XWINT (x30, 0) != 13LL)
        return -1;
      x31 = XVECEXP (x3, 0, 11);
      if (XWINT (x31, 0) != 45LL)
        return -1;
      x32 = XVECEXP (x3, 0, 12);
      if (XWINT (x32, 0) != 14LL)
        return -1;
      x33 = XVECEXP (x3, 0, 13);
      if (XWINT (x33, 0) != 46LL)
        return -1;
      x34 = XVECEXP (x3, 0, 14);
      if (XWINT (x34, 0) != 15LL)
        return -1;
      x35 = XVECEXP (x3, 0, 15);
      if (XWINT (x35, 0) != 47LL
          || XWINT (x4, 0) != 24LL
          || XWINT (x5, 0) != 56LL
          || XWINT (x6, 0) != 25LL
          || XWINT (x7, 0) != 57LL
          || XWINT (x8, 0) != 26LL
          || XWINT (x9, 0) != 58LL
          || XWINT (x10, 0) != 27LL
          || XWINT (x11, 0) != 59LL
          || XWINT (x12, 0) != 28LL
          || XWINT (x13, 0) != 60LL
          || XWINT (x14, 0) != 29LL
          || XWINT (x15, 0) != 61LL
          || XWINT (x16, 0) != 30LL
          || XWINT (x17, 0) != 62LL
          || XWINT (x18, 0) != 31LL
          || XWINT (x19, 0) != 63LL
          || !
#line 1496 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1779; /* lasx_xvilvh_b */

    case 1LL:
      x35 = XVECEXP (x3, 0, 15);
      if (XWINT (x35, 0) != 47LL
          || XWINT (x4, 0) != 17LL
          || XWINT (x19, 0) != 63LL)
        return -1;
      x21 = XVECEXP (x3, 0, 1);
      switch (XWINT (x21, 0))
        {
        case 33LL:
          x22 = XVECEXP (x3, 0, 2);
          if (XWINT (x22, 0) != 3LL)
            return -1;
          x23 = XVECEXP (x3, 0, 3);
          if (XWINT (x23, 0) != 35LL)
            return -1;
          x24 = XVECEXP (x3, 0, 4);
          if (XWINT (x24, 0) != 5LL)
            return -1;
          x25 = XVECEXP (x3, 0, 5);
          if (XWINT (x25, 0) != 37LL)
            return -1;
          x26 = XVECEXP (x3, 0, 6);
          if (XWINT (x26, 0) != 7LL)
            return -1;
          x27 = XVECEXP (x3, 0, 7);
          if (XWINT (x27, 0) != 39LL)
            return -1;
          x28 = XVECEXP (x3, 0, 8);
          if (XWINT (x28, 0) != 9LL)
            return -1;
          x29 = XVECEXP (x3, 0, 9);
          if (XWINT (x29, 0) != 41LL)
            return -1;
          x30 = XVECEXP (x3, 0, 10);
          if (XWINT (x30, 0) != 11LL)
            return -1;
          x31 = XVECEXP (x3, 0, 11);
          if (XWINT (x31, 0) != 43LL)
            return -1;
          x32 = XVECEXP (x3, 0, 12);
          if (XWINT (x32, 0) != 13LL)
            return -1;
          x33 = XVECEXP (x3, 0, 13);
          if (XWINT (x33, 0) != 45LL)
            return -1;
          x34 = XVECEXP (x3, 0, 14);
          if (XWINT (x34, 0) != 15LL
              || XWINT (x5, 0) != 49LL
              || XWINT (x6, 0) != 19LL
              || XWINT (x7, 0) != 51LL
              || XWINT (x8, 0) != 21LL
              || XWINT (x9, 0) != 53LL
              || XWINT (x10, 0) != 23LL
              || XWINT (x11, 0) != 55LL
              || XWINT (x12, 0) != 25LL
              || XWINT (x13, 0) != 57LL
              || XWINT (x14, 0) != 27LL
              || XWINT (x15, 0) != 59LL
              || XWINT (x16, 0) != 29LL
              || XWINT (x17, 0) != 61LL
              || XWINT (x18, 0) != 31LL
              || !
#line 1574 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1785; /* lasx_xvpackod_b */

        case 3LL:
          x22 = XVECEXP (x3, 0, 2);
          if (XWINT (x22, 0) != 5LL)
            return -1;
          x23 = XVECEXP (x3, 0, 3);
          if (XWINT (x23, 0) != 7LL)
            return -1;
          x24 = XVECEXP (x3, 0, 4);
          if (XWINT (x24, 0) != 9LL)
            return -1;
          x25 = XVECEXP (x3, 0, 5);
          if (XWINT (x25, 0) != 11LL)
            return -1;
          x26 = XVECEXP (x3, 0, 6);
          if (XWINT (x26, 0) != 13LL)
            return -1;
          x27 = XVECEXP (x3, 0, 7);
          if (XWINT (x27, 0) != 15LL)
            return -1;
          x28 = XVECEXP (x3, 0, 8);
          if (XWINT (x28, 0) != 33LL)
            return -1;
          x29 = XVECEXP (x3, 0, 9);
          if (XWINT (x29, 0) != 35LL)
            return -1;
          x30 = XVECEXP (x3, 0, 10);
          if (XWINT (x30, 0) != 37LL)
            return -1;
          x31 = XVECEXP (x3, 0, 11);
          if (XWINT (x31, 0) != 39LL)
            return -1;
          x32 = XVECEXP (x3, 0, 12);
          if (XWINT (x32, 0) != 41LL)
            return -1;
          x33 = XVECEXP (x3, 0, 13);
          if (XWINT (x33, 0) != 43LL)
            return -1;
          x34 = XVECEXP (x3, 0, 14);
          if (XWINT (x34, 0) != 45LL
              || XWINT (x5, 0) != 19LL
              || XWINT (x6, 0) != 21LL
              || XWINT (x7, 0) != 23LL
              || XWINT (x8, 0) != 25LL
              || XWINT (x9, 0) != 27LL
              || XWINT (x10, 0) != 29LL
              || XWINT (x11, 0) != 31LL
              || XWINT (x12, 0) != 49LL
              || XWINT (x13, 0) != 51LL
              || XWINT (x14, 0) != 53LL
              || XWINT (x15, 0) != 55LL
              || XWINT (x16, 0) != 57LL
              || XWINT (x17, 0) != 59LL
              || XWINT (x18, 0) != 61LL
              || !
#line 1902 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1827; /* lasx_xvpickod_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern132 (x3, 
E_SImode) != 0)
            return -1;
          return 100; /* *andsi3 */

        case E_DImode:
          if (pattern132 (x3, 
E_DImode) != 0
              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 101; /* *anddi3 */

        case E_V2DImode:
          if (pattern131 (x3, 
E_V2DImode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1016; /* andv2di3 */

        case E_V4SImode:
          if (pattern131 (x3, 
E_V4SImode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1017; /* andv4si3 */

        case E_V8HImode:
          if (pattern131 (x3, 
E_V8HImode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1018; /* andv8hi3 */

        case E_V16QImode:
          if (pattern131 (x3, 
E_V16QImode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1019; /* andv16qi3 */

        case E_V2DFmode:
          if (pattern131 (x3, 
E_V2DFmode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1020; /* andv2df3 */

        case E_V4SFmode:
          if (pattern131 (x3, 
E_V4SFmode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1021; /* andv4sf3 */

        case E_V4DImode:
          if (pattern131 (x3, 
E_V4DImode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1618; /* andv4di3 */

        case E_V8SImode:
          if (pattern131 (x3, 
E_V8SImode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1619; /* andv8si3 */

        case E_V16HImode:
          if (pattern131 (x3, 
E_V16HImode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1620; /* andv16hi3 */

        case E_V32QImode:
          if (pattern131 (x3, 
E_V32QImode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1621; /* andv32qi3 */

        case E_V4DFmode:
          if (pattern131 (x3, 
E_V4DFmode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1622; /* andv4df3 */

        case E_V8SFmode:
          if (pattern131 (x3, 
E_V8SFmode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1623; /* andv8sf3 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NOT:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern23 (x3, 
E_SImode) != 0)
                return -1;
              if (
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return 112; /* norsi3 */
              if (!
#line 1687 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 114; /* *norsi3_internal */

            case E_DImode:
              if (pattern23 (x3, 
E_DImode) != 0
                  || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 113; /* nordi3 */

            case E_V2DImode:
              if (pattern149 (x3, 
E_V2DImode) != 0
                  || !
#line 1617 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1215; /* lsx_nor_d */

            case E_V4SImode:
              if (pattern149 (x3, 
E_V4SImode) != 0
                  || !
#line 1617 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1216; /* lsx_nor_w */

            case E_V8HImode:
              if (pattern149 (x3, 
E_V8HImode) != 0
                  || !
#line 1617 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1217; /* lsx_nor_h */

            case E_V16QImode:
              if (pattern149 (x3, 
E_V16QImode) != 0
                  || !
#line 1617 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1218; /* lsx_nor_b */

            case E_V4DImode:
              if (pattern149 (x3, 
E_V4DImode) != 0
                  || !
#line 1797 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1819; /* lasx_xvnor_d */

            case E_V8SImode:
              if (pattern149 (x3, 
E_V8SImode) != 0
                  || !
#line 1797 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1820; /* lasx_xvnor_w */

            case E_V16HImode:
              if (pattern149 (x3, 
E_V16HImode) != 0
                  || !
#line 1797 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1821; /* lasx_xvnor_h */

            case E_V32QImode:
              if (pattern149 (x3, 
E_V32QImode) != 0
                  || !
#line 1797 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1822; /* lasx_xvnor_b */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern102 (x3) != 0)
                return -1;
              operands[1] = x5;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return 115; /* andnsi3 */
              operands[2] = x5;
              operands[1] = x6;
              if (!
#line 1707 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 119; /* *andnsi_internal */

            case E_DImode:
              if (pattern103 (x3, 
E_DImode) != 0
                  || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 117; /* andndi3 */

            case E_V2DImode:
              if (pattern103 (x3, 
E_V2DImode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1314; /* andnv2di3 */

            case E_V4SImode:
              if (pattern103 (x3, 
E_V4SImode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1315; /* andnv4si3 */

            case E_V8HImode:
              if (pattern103 (x3, 
E_V8HImode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1316; /* andnv8hi3 */

            case E_V16QImode:
              if (pattern103 (x3, 
E_V16QImode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1317; /* andnv16qi3 */

            case E_V2DFmode:
              if (pattern103 (x3, 
E_V2DFmode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1318; /* andnv2df3 */

            case E_V4SFmode:
              if (pattern103 (x3, 
E_V4SFmode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1319; /* andnv4sf3 */

            case E_V4DImode:
              if (pattern103 (x3, 
E_V4DImode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1941; /* andnv4di3 */

            case E_V8SImode:
              if (pattern103 (x3, 
E_V8SImode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1942; /* andnv8si3 */

            case E_V16HImode:
              if (pattern103 (x3, 
E_V16HImode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1943; /* andnv16hi3 */

            case E_V32QImode:
              if (pattern103 (x3, 
E_V32QImode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1944; /* andnv32qi3 */

            case E_V4DFmode:
              if (pattern103 (x3, 
E_V4DFmode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1945; /* andnv4df3 */

            case E_V8SFmode:
              if (pattern103 (x3, 
E_V8SFmode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1946; /* andnv8sf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern90 (x3))
        {
        case 0:
          if (!(
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !and_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
            return -1;
          return 260; /* and_shift_reversesi */

        case 1:
          if (!(
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !and_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 263; /* and_shift_reversedi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern83 (x3))
        {
        case 0:
          if (
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return 102; /* one_cmplsi2 */
          if (!
#line 1588 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 104; /* *one_cmplsi2_internal */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 103; /* one_cmpldi2 */

        case 2:
          if (!
#line 713 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1022; /* one_cmplv2di2 */

        case 3:
          if (!
#line 713 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1023; /* one_cmplv4si2 */

        case 4:
          if (!
#line 713 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1024; /* one_cmplv8hi2 */

        case 5:
          if (!
#line 713 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1025; /* one_cmplv16qi2 */

        case 6:
          if (!
#line 851 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1624; /* one_cmplv4di2 */

        case 7:
          if (!
#line 851 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1625; /* one_cmplv8si2 */

        case 8:
          if (!
#line 851 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1626; /* one_cmplv16hi2 */

        case 9:
          if (!
#line 851 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1627; /* one_cmplv32qi2 */

        default:
          return -1;
        }

    case GE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 715; /* lsx_vfcmp_sult_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 719; /* lsx_vfcmp_sult_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 723; /* lasx_xvfcmp_sult_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 727; /* lasx_xvfcmp_sult_s */

        default:
          return -1;
        }

    case GT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 716; /* lsx_vfcmp_sule_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 720; /* lsx_vfcmp_sule_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 724; /* lasx_xvfcmp_sule_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 728; /* lasx_xvfcmp_sule_s */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 717; /* lsx_vfcmp_clt_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 721; /* lsx_vfcmp_clt_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 725; /* lasx_xvfcmp_clt_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 729; /* lasx_xvfcmp_clt_s */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 718; /* lsx_vfcmp_cle_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 722; /* lsx_vfcmp_cle_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 726; /* lasx_xvfcmp_cle_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 730; /* lasx_xvfcmp_cle_s */

        default:
          return -1;
        }

    case LE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 731; /* lsx_vfcmp_sugt_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 735; /* lsx_vfcmp_sugt_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 739; /* lasx_xvfcmp_sugt_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 743; /* lasx_xvfcmp_sugt_s */

        default:
          return -1;
        }

    case LT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 732; /* lsx_vfcmp_suge_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 736; /* lsx_vfcmp_suge_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 740; /* lasx_xvfcmp_suge_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 744; /* lasx_xvfcmp_suge_s */

        default:
          return -1;
        }

    case UNLE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 733; /* lsx_vfcmp_cgt_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 737; /* lsx_vfcmp_cgt_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 741; /* lasx_xvfcmp_cgt_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 745; /* lasx_xvfcmp_cgt_s */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 734; /* lsx_vfcmp_cge_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 738; /* lsx_vfcmp_cge_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 742; /* lasx_xvfcmp_cge_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 746; /* lasx_xvfcmp_cge_s */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (pattern121 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 303; /* *sle_sisi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 305; /* *sle_disi */

        case 2:
          if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 307; /* *sle_didi */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_FCCmode:
          switch (pattern11 (x3))
            {
            case 0:
              if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 315; /* sle_sf_using_FCCmode */

            case 1:
              if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 329; /* sle_df_using_FCCmode */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern117 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 665; /* lsx_vfcmp_sle_d */

            case 1:
              if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1118; /* lsx_vsle_d */

            default:
              return -1;
            }

        case E_V4SImode:
          switch (pattern118 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 675; /* lsx_vfcmp_sle_s */

            case 1:
              if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1123; /* lsx_vsle_w */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern119 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 685; /* lasx_xvfcmp_sle_d */

            case 1:
              if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1722; /* lasx_xvsle_d */

            default:
              return -1;
            }

        case E_V8SImode:
          switch (pattern120 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 695; /* lasx_xvfcmp_sle_s */

            case 1:
              if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1727; /* lasx_xvsle_w */

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern2 (x3, 
E_V8HImode) != 0
              || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1128; /* lsx_vsle_h */

        case E_V16QImode:
          if (pattern2 (x3, 
E_V16QImode) != 0
              || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1133; /* lsx_vsle_b */

        case E_V16HImode:
          if (pattern2 (x3, 
E_V16HImode) != 0
              || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1732; /* lasx_xvsle_h */

        case E_V32QImode:
          if (pattern2 (x3, 
E_V32QImode) != 0
              || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1737; /* lasx_xvsle_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 291; /* *sgt_sisi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 293; /* *sgt_disi */

        default:
          return -1;
        }

    case E_DImode:
      if (pattern115 (x3) != 0
          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 295; /* *sgt_didi */

    case E_FCCmode:
      switch (pattern11 (x3))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 320; /* sgt_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 334; /* sgt_df_using_FCCmode */

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern12 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 700; /* lsx_vfcmp_sgt_d */

    case E_V4SImode:
      if (pattern12 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 704; /* lsx_vfcmp_sgt_s */

    case E_V4DImode:
      if (pattern12 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
          || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 708; /* lasx_xvfcmp_sgt_d */

    case E_V8SImode:
      if (pattern12 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
          || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 712; /* lasx_xvfcmp_sgt_s */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case TRAP_IF:
      x2 = XEXP (x1, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 1; /* trap */

    case SET:
      return recog_134 (x1, insn, pnum_clobbers);

    case PARALLEL:
      return recog_135 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x4 = XVECEXP (x1, 0, 0);
          operands[0] = x4;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          switch (XINT (x1, 1))
            {
            case 16:
              if (GET_MODE (x1) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 2884 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 220; /* loongarch_asrtle_d */

            case 17:
              if (GET_MODE (x1) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 2893 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 221; /* loongarch_asrtgt_d */

            case 14:
              if (!const_uimm5_operand (operands[0], E_VOIDmode)
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 4184 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 375; /* loongarch_movgr2fcsr */

            default:
              return -1;
            }

        case 1:
          if (XINT (x1, 1) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 343; /* blockage */

        default:
          return -1;
        }

    case RETURN:
      return 346; /* *return */

    case SIMPLE_RETURN:
      return 347; /* *simple_return */

    case EH_RETURN:
      return 351; /* eh_return_internal */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 14)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 3717 "../../gcc/config/loongarch/loongarch.md"
(! TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 352; /* eh_set_ra_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 3723 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 353; /* eh_set_ra_di */

        default:
          return -1;
        }

    case CALL:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != MEM)
        return -1;
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[0] = x6;
          if (!call_insn_operand (operands[0], E_VOIDmode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 1);
          operands[1] = x3;
          if (
#line 3774 "../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
            return 354; /* sibcall_internal */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 363; /* call_internal */

        case LO_SUM:
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          x8 = XEXP (x6, 1);
          operands[1] = x8;
          x3 = XEXP (x1, 1);
          operands[2] = x3;
          switch (GET_MODE (x2))
            {
            case E_SImode:
              if (GET_MODE (x6) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !symbolic_operand (operands[1], E_SImode))
                return -1;
              if ((
#line 3800 "../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return 355; /* sibcall_internal_1si */
              if (pnum_clobbers == NULL
                  || !(
#line 3990 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return -1;
              *pnum_clobbers = 1;
              return 364; /* call_internal_1si */

            case E_DImode:
              if (GET_MODE (x6) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !symbolic_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 3800 "../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return 356; /* sibcall_internal_1di */
              if (pnum_clobbers == NULL
                  || !(
#line 3990 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return -1;
              *pnum_clobbers = 1;
              return 365; /* call_internal_1di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PREFETCH:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x9 = XEXP (x1, 2);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      return 372; /* prefetch */

    case CONST_INT:
      if (XWINT (x1, 0) != 0LL)
        return -1;
      return 373; /* nop */

    default:
      return -1;
    }
}
